package br.mp.mprj.portal.portlet.gestaomensagens.service.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

/**
 * The base model interface for the EmailDestinatario service. Represents a row in the &quot;PRT_GESTMSG_MAIL_DESTINATARIO&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.EmailDestinatarioModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.EmailDestinatarioImpl}.
 * </p>
 *
 * @author Henrique Simoes
 * @see EmailDestinatario
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.EmailDestinatarioImpl
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.EmailDestinatarioModelImpl
 * @generated
 */
public interface EmailDestinatarioModel extends BaseModel<EmailDestinatario> {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this interface directly. All methods that expect a email destinatario model instance should use the {@link EmailDestinatario} interface instead.
     */

    /**
     * Returns the primary key of this email destinatario.
     *
     * @return the primary key of this email destinatario
     */
    public long getPrimaryKey();

    /**
     * Sets the primary key of this email destinatario.
     *
     * @param primaryKey the primary key of this email destinatario
     */
    public void setPrimaryKey(long primaryKey);

    /**
     * Returns the uuid of this email destinatario.
     *
     * @return the uuid of this email destinatario
     */
    @AutoEscape
    public String getUuid();

    /**
     * Sets the uuid of this email destinatario.
     *
     * @param uuid the uuid of this email destinatario
     */
    public void setUuid(String uuid);

    /**
     * Returns the email destinatario ID of this email destinatario.
     *
     * @return the email destinatario ID of this email destinatario
     */
    public long getEmailDestinatarioId();

    /**
     * Sets the email destinatario ID of this email destinatario.
     *
     * @param emailDestinatarioId the email destinatario ID of this email destinatario
     */
    public void setEmailDestinatarioId(long emailDestinatarioId);

    /**
     * Returns the email of this email destinatario.
     *
     * @return the email of this email destinatario
     */
    @AutoEscape
    public String getEmail();

    /**
     * Sets the email of this email destinatario.
     *
     * @param email the email of this email destinatario
     */
    public void setEmail(String email);

    /**
     * Returns the grupo destinatario ID of this email destinatario.
     *
     * @return the grupo destinatario ID of this email destinatario
     */
    public long getGrupoDestinatarioId();

    /**
     * Sets the grupo destinatario ID of this email destinatario.
     *
     * @param grupoDestinatarioId the grupo destinatario ID of this email destinatario
     */
    public void setGrupoDestinatarioId(long grupoDestinatarioId);

    @Override
    public boolean isNew();

    @Override
    public void setNew(boolean n);

    @Override
    public boolean isCachedModel();

    @Override
    public void setCachedModel(boolean cachedModel);

    @Override
    public boolean isEscapedModel();

    @Override
    public Serializable getPrimaryKeyObj();

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj);

    @Override
    public ExpandoBridge getExpandoBridge();

    @Override
    public void setExpandoBridgeAttributes(BaseModel<?> baseModel);

    @Override
    public void setExpandoBridgeAttributes(ExpandoBridge expandoBridge);

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext);

    @Override
    public Object clone();

    @Override
    public int compareTo(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.EmailDestinatario emailDestinatario);

    @Override
    public int hashCode();

    @Override
    public CacheModel<br.mp.mprj.portal.portlet.gestaomensagens.service.model.EmailDestinatario> toCacheModel();

    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.EmailDestinatario toEscapedModel();

    @Override
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.EmailDestinatario toUnescapedModel();

    @Override
    public String toString();

    @Override
    public String toXmlString();
}
