package br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl;

import br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template;
import br.mp.mprj.portal.portlet.gestaomensagens.service.model.TemplateModel;
import br.mp.mprj.portal.portlet.gestaomensagens.service.model.TemplateSoap;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.json.JSON;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.util.PortalUtil;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import java.io.Serializable;

import java.sql.Types;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * The base model implementation for the Template service. Represents a row in the &quot;PRT_GESTMSG_TEMPLATE&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.TemplateModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link TemplateImpl}.
 * </p>
 *
 * @author Henrique Simoes
 * @see TemplateImpl
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.model.TemplateModel
 * @generated
 */
@JSON(strict = true)
public class TemplateModelImpl extends BaseModelImpl<Template>
    implements TemplateModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a template model instance should use the {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template} interface instead.
     */
    public static final String TABLE_NAME = "PRT_GESTMSG_TEMPLATE";
    public static final Object[][] TABLE_COLUMNS = {
            { "uuid_", Types.VARCHAR },
            { "templateId", Types.BIGINT },
            { "companyId", Types.BIGINT },
            { "groupId", Types.BIGINT },
            { "userId", Types.BIGINT },
            { "nome", Types.VARCHAR },
            { "estilo", Types.INTEGER },
            { "ativo", Types.BOOLEAN },
            { "cabecalho", Types.CLOB },
            { "rodape", Types.CLOB },
            { "corpo", Types.CLOB },
            { "dataCriacao", Types.TIMESTAMP },
            { "dataAtualizacao", Types.TIMESTAMP },
            { "thumbnailFileEntryId", Types.BIGINT },
            { "thumbnailURL", Types.VARCHAR }
        };
    public static final String TABLE_SQL_CREATE = "create table PRT_GESTMSG_TEMPLATE (uuid_ VARCHAR(75) null,templateId LONG not null primary key,companyId LONG,groupId LONG,userId LONG,nome VARCHAR(255) null,estilo INTEGER,ativo BOOLEAN,cabecalho TEXT null,rodape TEXT null,corpo TEXT null,dataCriacao DATE null,dataAtualizacao DATE null,thumbnailFileEntryId LONG,thumbnailURL VARCHAR(255) null)";
    public static final String TABLE_SQL_DROP = "drop table PRT_GESTMSG_TEMPLATE";
    public static final String ORDER_BY_JPQL = " ORDER BY template.templateId ASC";
    public static final String ORDER_BY_SQL = " ORDER BY PRT_GESTMSG_TEMPLATE.templateId ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template"),
            true);
    public static long ATIVO_COLUMN_BITMASK = 1L;
    public static long COMPANYID_COLUMN_BITMASK = 2L;
    public static long GROUPID_COLUMN_BITMASK = 4L;
    public static long NOME_COLUMN_BITMASK = 8L;
    public static long UUID_COLUMN_BITMASK = 16L;
    public static long TEMPLATEID_COLUMN_BITMASK = 32L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template"));
    private static ClassLoader _classLoader = Template.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] {
            Template.class
        };
    private String _uuid;
    private String _originalUuid;
    private long _templateId;
    private long _companyId;
    private long _originalCompanyId;
    private boolean _setOriginalCompanyId;
    private long _groupId;
    private long _originalGroupId;
    private boolean _setOriginalGroupId;
    private long _userId;
    private String _userUuid;
    private String _nome;
    private String _originalNome;
    private int _estilo;
    private boolean _ativo;
    private boolean _originalAtivo;
    private boolean _setOriginalAtivo;
    private String _cabecalho;
    private String _rodape;
    private String _corpo;
    private Date _dataCriacao;
    private Date _dataAtualizacao;
    private long _thumbnailFileEntryId;
    private String _thumbnailURL;
    private long _columnBitmask;
    private Template _escapedModel;

    public TemplateModelImpl() {
    }

    /**
     * Converts the soap model instance into a normal model instance.
     *
     * @param soapModel the soap model instance to convert
     * @return the normal model instance
     */
    public static Template toModel(TemplateSoap soapModel) {
        if (soapModel == null) {
            return null;
        }

        Template model = new TemplateImpl();

        model.setUuid(soapModel.getUuid());
        model.setTemplateId(soapModel.getTemplateId());
        model.setCompanyId(soapModel.getCompanyId());
        model.setGroupId(soapModel.getGroupId());
        model.setUserId(soapModel.getUserId());
        model.setNome(soapModel.getNome());
        model.setEstilo(soapModel.getEstilo());
        model.setAtivo(soapModel.getAtivo());
        model.setCabecalho(soapModel.getCabecalho());
        model.setRodape(soapModel.getRodape());
        model.setCorpo(soapModel.getCorpo());
        model.setDataCriacao(soapModel.getDataCriacao());
        model.setDataAtualizacao(soapModel.getDataAtualizacao());
        model.setThumbnailFileEntryId(soapModel.getThumbnailFileEntryId());
        model.setThumbnailURL(soapModel.getThumbnailURL());

        return model;
    }

    /**
     * Converts the soap model instances into normal model instances.
     *
     * @param soapModels the soap model instances to convert
     * @return the normal model instances
     */
    public static List<Template> toModels(TemplateSoap[] soapModels) {
        if (soapModels == null) {
            return null;
        }

        List<Template> models = new ArrayList<Template>(soapModels.length);

        for (TemplateSoap soapModel : soapModels) {
            models.add(toModel(soapModel));
        }

        return models;
    }

    @Override
    public long getPrimaryKey() {
        return _templateId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setTemplateId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _templateId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return Template.class;
    }

    @Override
    public String getModelClassName() {
        return Template.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("uuid", getUuid());
        attributes.put("templateId", getTemplateId());
        attributes.put("companyId", getCompanyId());
        attributes.put("groupId", getGroupId());
        attributes.put("userId", getUserId());
        attributes.put("nome", getNome());
        attributes.put("estilo", getEstilo());
        attributes.put("ativo", getAtivo());
        attributes.put("cabecalho", getCabecalho());
        attributes.put("rodape", getRodape());
        attributes.put("corpo", getCorpo());
        attributes.put("dataCriacao", getDataCriacao());
        attributes.put("dataAtualizacao", getDataAtualizacao());
        attributes.put("thumbnailFileEntryId", getThumbnailFileEntryId());
        attributes.put("thumbnailURL", getThumbnailURL());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        String uuid = (String) attributes.get("uuid");

        if (uuid != null) {
            setUuid(uuid);
        }

        Long templateId = (Long) attributes.get("templateId");

        if (templateId != null) {
            setTemplateId(templateId);
        }

        Long companyId = (Long) attributes.get("companyId");

        if (companyId != null) {
            setCompanyId(companyId);
        }

        Long groupId = (Long) attributes.get("groupId");

        if (groupId != null) {
            setGroupId(groupId);
        }

        Long userId = (Long) attributes.get("userId");

        if (userId != null) {
            setUserId(userId);
        }

        String nome = (String) attributes.get("nome");

        if (nome != null) {
            setNome(nome);
        }

        Integer estilo = (Integer) attributes.get("estilo");

        if (estilo != null) {
            setEstilo(estilo);
        }

        Boolean ativo = (Boolean) attributes.get("ativo");

        if (ativo != null) {
            setAtivo(ativo);
        }

        String cabecalho = (String) attributes.get("cabecalho");

        if (cabecalho != null) {
            setCabecalho(cabecalho);
        }

        String rodape = (String) attributes.get("rodape");

        if (rodape != null) {
            setRodape(rodape);
        }

        String corpo = (String) attributes.get("corpo");

        if (corpo != null) {
            setCorpo(corpo);
        }

        Date dataCriacao = (Date) attributes.get("dataCriacao");

        if (dataCriacao != null) {
            setDataCriacao(dataCriacao);
        }

        Date dataAtualizacao = (Date) attributes.get("dataAtualizacao");

        if (dataAtualizacao != null) {
            setDataAtualizacao(dataAtualizacao);
        }

        Long thumbnailFileEntryId = (Long) attributes.get(
                "thumbnailFileEntryId");

        if (thumbnailFileEntryId != null) {
            setThumbnailFileEntryId(thumbnailFileEntryId);
        }

        String thumbnailURL = (String) attributes.get("thumbnailURL");

        if (thumbnailURL != null) {
            setThumbnailURL(thumbnailURL);
        }
    }

    @JSON
    @Override
    public String getUuid() {
        if (_uuid == null) {
            return StringPool.BLANK;
        } else {
            return _uuid;
        }
    }

    @Override
    public void setUuid(String uuid) {
        if (_originalUuid == null) {
            _originalUuid = _uuid;
        }

        _uuid = uuid;
    }

    public String getOriginalUuid() {
        return GetterUtil.getString(_originalUuid);
    }

    @JSON
    @Override
    public long getTemplateId() {
        return _templateId;
    }

    @Override
    public void setTemplateId(long templateId) {
        _templateId = templateId;
    }

    @JSON
    @Override
    public long getCompanyId() {
        return _companyId;
    }

    @Override
    public void setCompanyId(long companyId) {
        _columnBitmask |= COMPANYID_COLUMN_BITMASK;

        if (!_setOriginalCompanyId) {
            _setOriginalCompanyId = true;

            _originalCompanyId = _companyId;
        }

        _companyId = companyId;
    }

    public long getOriginalCompanyId() {
        return _originalCompanyId;
    }

    @JSON
    @Override
    public long getGroupId() {
        return _groupId;
    }

    @Override
    public void setGroupId(long groupId) {
        _columnBitmask |= GROUPID_COLUMN_BITMASK;

        if (!_setOriginalGroupId) {
            _setOriginalGroupId = true;

            _originalGroupId = _groupId;
        }

        _groupId = groupId;
    }

    public long getOriginalGroupId() {
        return _originalGroupId;
    }

    @JSON
    @Override
    public long getUserId() {
        return _userId;
    }

    @Override
    public void setUserId(long userId) {
        _userId = userId;
    }

    @Override
    public String getUserUuid() throws SystemException {
        return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
    }

    @Override
    public void setUserUuid(String userUuid) {
        _userUuid = userUuid;
    }

    @JSON
    @Override
    public String getNome() {
        if (_nome == null) {
            return StringPool.BLANK;
        } else {
            return _nome;
        }
    }

    @Override
    public void setNome(String nome) {
        _columnBitmask |= NOME_COLUMN_BITMASK;

        if (_originalNome == null) {
            _originalNome = _nome;
        }

        _nome = nome;
    }

    public String getOriginalNome() {
        return GetterUtil.getString(_originalNome);
    }

    @JSON
    @Override
    public int getEstilo() {
        return _estilo;
    }

    @Override
    public void setEstilo(int estilo) {
        _estilo = estilo;
    }

    @JSON
    @Override
    public boolean getAtivo() {
        return _ativo;
    }

    @Override
    public boolean isAtivo() {
        return _ativo;
    }

    @Override
    public void setAtivo(boolean ativo) {
        _columnBitmask |= ATIVO_COLUMN_BITMASK;

        if (!_setOriginalAtivo) {
            _setOriginalAtivo = true;

            _originalAtivo = _ativo;
        }

        _ativo = ativo;
    }

    public boolean getOriginalAtivo() {
        return _originalAtivo;
    }

    @JSON
    @Override
    public String getCabecalho() {
        if (_cabecalho == null) {
            return StringPool.BLANK;
        } else {
            return _cabecalho;
        }
    }

    @Override
    public void setCabecalho(String cabecalho) {
        _cabecalho = cabecalho;
    }

    @JSON
    @Override
    public String getRodape() {
        if (_rodape == null) {
            return StringPool.BLANK;
        } else {
            return _rodape;
        }
    }

    @Override
    public void setRodape(String rodape) {
        _rodape = rodape;
    }

    @JSON
    @Override
    public String getCorpo() {
        if (_corpo == null) {
            return StringPool.BLANK;
        } else {
            return _corpo;
        }
    }

    @Override
    public void setCorpo(String corpo) {
        _corpo = corpo;
    }

    @JSON
    @Override
    public Date getDataCriacao() {
        return _dataCriacao;
    }

    @Override
    public void setDataCriacao(Date dataCriacao) {
        _dataCriacao = dataCriacao;
    }

    @JSON
    @Override
    public Date getDataAtualizacao() {
        return _dataAtualizacao;
    }

    @Override
    public void setDataAtualizacao(Date dataAtualizacao) {
        _dataAtualizacao = dataAtualizacao;
    }

    @JSON
    @Override
    public long getThumbnailFileEntryId() {
        return _thumbnailFileEntryId;
    }

    @Override
    public void setThumbnailFileEntryId(long thumbnailFileEntryId) {
        _thumbnailFileEntryId = thumbnailFileEntryId;
    }

    @JSON
    @Override
    public String getThumbnailURL() {
        if (_thumbnailURL == null) {
            return StringPool.BLANK;
        } else {
            return _thumbnailURL;
        }
    }

    @Override
    public void setThumbnailURL(String thumbnailURL) {
        _thumbnailURL = thumbnailURL;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(getCompanyId(),
            Template.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public Template toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (Template) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        TemplateImpl templateImpl = new TemplateImpl();

        templateImpl.setUuid(getUuid());
        templateImpl.setTemplateId(getTemplateId());
        templateImpl.setCompanyId(getCompanyId());
        templateImpl.setGroupId(getGroupId());
        templateImpl.setUserId(getUserId());
        templateImpl.setNome(getNome());
        templateImpl.setEstilo(getEstilo());
        templateImpl.setAtivo(getAtivo());
        templateImpl.setCabecalho(getCabecalho());
        templateImpl.setRodape(getRodape());
        templateImpl.setCorpo(getCorpo());
        templateImpl.setDataCriacao(getDataCriacao());
        templateImpl.setDataAtualizacao(getDataAtualizacao());
        templateImpl.setThumbnailFileEntryId(getThumbnailFileEntryId());
        templateImpl.setThumbnailURL(getThumbnailURL());

        templateImpl.resetOriginalValues();

        return templateImpl;
    }

    @Override
    public int compareTo(Template template) {
        long primaryKey = template.getPrimaryKey();

        if (getPrimaryKey() < primaryKey) {
            return -1;
        } else if (getPrimaryKey() > primaryKey) {
            return 1;
        } else {
            return 0;
        }
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof Template)) {
            return false;
        }

        Template template = (Template) obj;

        long primaryKey = template.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        TemplateModelImpl templateModelImpl = this;

        templateModelImpl._originalUuid = templateModelImpl._uuid;

        templateModelImpl._originalCompanyId = templateModelImpl._companyId;

        templateModelImpl._setOriginalCompanyId = false;

        templateModelImpl._originalGroupId = templateModelImpl._groupId;

        templateModelImpl._setOriginalGroupId = false;

        templateModelImpl._originalNome = templateModelImpl._nome;

        templateModelImpl._originalAtivo = templateModelImpl._ativo;

        templateModelImpl._setOriginalAtivo = false;

        templateModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<Template> toCacheModel() {
        TemplateCacheModel templateCacheModel = new TemplateCacheModel();

        templateCacheModel.uuid = getUuid();

        String uuid = templateCacheModel.uuid;

        if ((uuid != null) && (uuid.length() == 0)) {
            templateCacheModel.uuid = null;
        }

        templateCacheModel.templateId = getTemplateId();

        templateCacheModel.companyId = getCompanyId();

        templateCacheModel.groupId = getGroupId();

        templateCacheModel.userId = getUserId();

        templateCacheModel.nome = getNome();

        String nome = templateCacheModel.nome;

        if ((nome != null) && (nome.length() == 0)) {
            templateCacheModel.nome = null;
        }

        templateCacheModel.estilo = getEstilo();

        templateCacheModel.ativo = getAtivo();

        templateCacheModel.cabecalho = getCabecalho();

        String cabecalho = templateCacheModel.cabecalho;

        if ((cabecalho != null) && (cabecalho.length() == 0)) {
            templateCacheModel.cabecalho = null;
        }

        templateCacheModel.rodape = getRodape();

        String rodape = templateCacheModel.rodape;

        if ((rodape != null) && (rodape.length() == 0)) {
            templateCacheModel.rodape = null;
        }

        templateCacheModel.corpo = getCorpo();

        String corpo = templateCacheModel.corpo;

        if ((corpo != null) && (corpo.length() == 0)) {
            templateCacheModel.corpo = null;
        }

        Date dataCriacao = getDataCriacao();

        if (dataCriacao != null) {
            templateCacheModel.dataCriacao = dataCriacao.getTime();
        } else {
            templateCacheModel.dataCriacao = Long.MIN_VALUE;
        }

        Date dataAtualizacao = getDataAtualizacao();

        if (dataAtualizacao != null) {
            templateCacheModel.dataAtualizacao = dataAtualizacao.getTime();
        } else {
            templateCacheModel.dataAtualizacao = Long.MIN_VALUE;
        }

        templateCacheModel.thumbnailFileEntryId = getThumbnailFileEntryId();

        templateCacheModel.thumbnailURL = getThumbnailURL();

        String thumbnailURL = templateCacheModel.thumbnailURL;

        if ((thumbnailURL != null) && (thumbnailURL.length() == 0)) {
            templateCacheModel.thumbnailURL = null;
        }

        return templateCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(31);

        sb.append("{uuid=");
        sb.append(getUuid());
        sb.append(", templateId=");
        sb.append(getTemplateId());
        sb.append(", companyId=");
        sb.append(getCompanyId());
        sb.append(", groupId=");
        sb.append(getGroupId());
        sb.append(", userId=");
        sb.append(getUserId());
        sb.append(", nome=");
        sb.append(getNome());
        sb.append(", estilo=");
        sb.append(getEstilo());
        sb.append(", ativo=");
        sb.append(getAtivo());
        sb.append(", cabecalho=");
        sb.append(getCabecalho());
        sb.append(", rodape=");
        sb.append(getRodape());
        sb.append(", corpo=");
        sb.append(getCorpo());
        sb.append(", dataCriacao=");
        sb.append(getDataCriacao());
        sb.append(", dataAtualizacao=");
        sb.append(getDataAtualizacao());
        sb.append(", thumbnailFileEntryId=");
        sb.append(getThumbnailFileEntryId());
        sb.append(", thumbnailURL=");
        sb.append(getThumbnailURL());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(49);

        sb.append("<model><model-name>");
        sb.append(
            "br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>uuid</column-name><column-value><![CDATA[");
        sb.append(getUuid());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>templateId</column-name><column-value><![CDATA[");
        sb.append(getTemplateId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>companyId</column-name><column-value><![CDATA[");
        sb.append(getCompanyId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>groupId</column-name><column-value><![CDATA[");
        sb.append(getGroupId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>userId</column-name><column-value><![CDATA[");
        sb.append(getUserId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>nome</column-name><column-value><![CDATA[");
        sb.append(getNome());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>estilo</column-name><column-value><![CDATA[");
        sb.append(getEstilo());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>ativo</column-name><column-value><![CDATA[");
        sb.append(getAtivo());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>cabecalho</column-name><column-value><![CDATA[");
        sb.append(getCabecalho());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>rodape</column-name><column-value><![CDATA[");
        sb.append(getRodape());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>corpo</column-name><column-value><![CDATA[");
        sb.append(getCorpo());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>dataCriacao</column-name><column-value><![CDATA[");
        sb.append(getDataCriacao());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>dataAtualizacao</column-name><column-value><![CDATA[");
        sb.append(getDataAtualizacao());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>thumbnailFileEntryId</column-name><column-value><![CDATA[");
        sb.append(getThumbnailFileEntryId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>thumbnailURL</column-name><column-value><![CDATA[");
        sb.append(getThumbnailURL());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
