package br.mp.mprj.portal.portlet.gestaomensagens.service.service;

import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.search.IndexableType;
import com.liferay.portal.kernel.transaction.Isolation;
import com.liferay.portal.kernel.transaction.Propagation;
import com.liferay.portal.kernel.transaction.Transactional;
import com.liferay.portal.service.BaseLocalService;
import com.liferay.portal.service.InvokableLocalService;
import com.liferay.portal.service.PersistedModelLocalService;

/**
 * Provides the local service interface for AnexoMensagem. Methods of this
 * service will not have security checks based on the propagated JAAS
 * credentials because this service can only be accessed from within the same
 * VM.
 *
 * @author Henrique Simoes
 * @see AnexoMensagemLocalServiceUtil
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.service.base.AnexoMensagemLocalServiceBaseImpl
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.service.impl.AnexoMensagemLocalServiceImpl
 * @generated
 */
@Transactional(isolation = Isolation.PORTAL, rollbackFor =  {
    PortalException.class, SystemException.class}
)
public interface AnexoMensagemLocalService extends BaseLocalService,
    InvokableLocalService, PersistedModelLocalService {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this interface directly. Always use {@link AnexoMensagemLocalServiceUtil} to access the anexo mensagem local service. Add custom service methods to {@link br.mp.mprj.portal.portlet.gestaomensagens.service.service.impl.AnexoMensagemLocalServiceImpl} and rerun ServiceBuilder to automatically copy the method declarations to this interface.
     */

    /**
    * Adds the anexo mensagem to the database. Also notifies the appropriate model listeners.
    *
    * @param anexoMensagem the anexo mensagem
    * @return the anexo mensagem that was added
    * @throws SystemException if a system exception occurred
    */
    @com.liferay.portal.kernel.search.Indexable(type = IndexableType.REINDEX)
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem addAnexoMensagem(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem anexoMensagem)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Creates a new anexo mensagem with the primary key. Does not add the anexo mensagem to the database.
    *
    * @param anexoMensagemId the primary key for the new anexo mensagem
    * @return the new anexo mensagem
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem createAnexoMensagem(
        long anexoMensagemId);

    /**
    * Deletes the anexo mensagem with the primary key from the database. Also notifies the appropriate model listeners.
    *
    * @param anexoMensagemId the primary key of the anexo mensagem
    * @return the anexo mensagem that was removed
    * @throws PortalException if a anexo mensagem with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    @com.liferay.portal.kernel.search.Indexable(type = IndexableType.DELETE)
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem deleteAnexoMensagem(
        long anexoMensagemId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Deletes the anexo mensagem from the database. Also notifies the appropriate model listeners.
    *
    * @param anexoMensagem the anexo mensagem
    * @return the anexo mensagem that was removed
    * @throws SystemException if a system exception occurred
    */
    @com.liferay.portal.kernel.search.Indexable(type = IndexableType.DELETE)
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem deleteAnexoMensagem(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem anexoMensagem)
        throws com.liferay.portal.kernel.exception.SystemException;

    public com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery();

    /**
    * Performs a dynamic query on the database and returns the matching rows.
    *
    * @param dynamicQuery the dynamic query
    * @return the matching rows
    * @throws SystemException if a system exception occurred
    */
    @SuppressWarnings("rawtypes")
    public java.util.List dynamicQuery(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Performs a dynamic query on the database and returns a range of the matching rows.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param dynamicQuery the dynamic query
    * @param start the lower bound of the range of model instances
    * @param end the upper bound of the range of model instances (not inclusive)
    * @return the range of matching rows
    * @throws SystemException if a system exception occurred
    */
    @SuppressWarnings("rawtypes")
    public java.util.List dynamicQuery(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
        int end) throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Performs a dynamic query on the database and returns an ordered range of the matching rows.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param dynamicQuery the dynamic query
    * @param start the lower bound of the range of model instances
    * @param end the upper bound of the range of model instances (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching rows
    * @throws SystemException if a system exception occurred
    */
    @SuppressWarnings("rawtypes")
    public java.util.List dynamicQuery(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
        int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of rows that match the dynamic query.
    *
    * @param dynamicQuery the dynamic query
    * @return the number of rows that match the dynamic query
    * @throws SystemException if a system exception occurred
    */
    public long dynamicQueryCount(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of rows that match the dynamic query.
    *
    * @param dynamicQuery the dynamic query
    * @param projection the projection to apply to the query
    * @return the number of rows that match the dynamic query
    * @throws SystemException if a system exception occurred
    */
    public long dynamicQueryCount(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery,
        com.liferay.portal.kernel.dao.orm.Projection projection)
        throws com.liferay.portal.kernel.exception.SystemException;

    @Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem fetchAnexoMensagem(
        long anexoMensagemId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the anexo mensagem with the matching UUID and company.
    *
    * @param uuid the anexo mensagem's UUID
    * @param companyId the primary key of the company
    * @return the matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    @Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem fetchAnexoMensagemByUuidAndCompanyId(
        java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the anexo mensagem matching the UUID and group.
    *
    * @param uuid the anexo mensagem's UUID
    * @param groupId the primary key of the group
    * @return the matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    @Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem fetchAnexoMensagemByUuidAndGroupId(
        java.lang.String uuid, long groupId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the anexo mensagem with the primary key.
    *
    * @param anexoMensagemId the primary key of the anexo mensagem
    * @return the anexo mensagem
    * @throws PortalException if a anexo mensagem with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    @Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem getAnexoMensagem(
        long anexoMensagemId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException;

    @Override
    @Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
    public com.liferay.portal.model.PersistedModel getPersistedModel(
        java.io.Serializable primaryKeyObj)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the anexo mensagem with the matching UUID and company.
    *
    * @param uuid the anexo mensagem's UUID
    * @param companyId the primary key of the company
    * @return the matching anexo mensagem
    * @throws PortalException if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    @Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem getAnexoMensagemByUuidAndCompanyId(
        java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the anexo mensagem matching the UUID and group.
    *
    * @param uuid the anexo mensagem's UUID
    * @param groupId the primary key of the group
    * @return the matching anexo mensagem
    * @throws PortalException if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    @Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem getAnexoMensagemByUuidAndGroupId(
        java.lang.String uuid, long groupId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the anexo mensagems.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param start the lower bound of the range of anexo mensagems
    * @param end the upper bound of the range of anexo mensagems (not inclusive)
    * @return the range of anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    @Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> getAnexoMensagems(
        int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of anexo mensagems.
    *
    * @return the number of anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    @Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
    public int getAnexoMensagemsCount()
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Updates the anexo mensagem in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
    *
    * @param anexoMensagem the anexo mensagem
    * @return the anexo mensagem that was updated
    * @throws SystemException if a system exception occurred
    */
    @com.liferay.portal.kernel.search.Indexable(type = IndexableType.REINDEX)
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem updateAnexoMensagem(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem anexoMensagem)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the Spring bean ID for this bean.
    *
    * @return the Spring bean ID for this bean
    */
    public java.lang.String getBeanIdentifier();

    /**
    * Sets the Spring bean ID for this bean.
    *
    * @param beanIdentifier the Spring bean ID for this bean
    */
    public void setBeanIdentifier(java.lang.String beanIdentifier);

    @Override
    public java.lang.Object invokeMethod(java.lang.String name,
        java.lang.String[] parameterTypes, java.lang.Object[] arguments)
        throws java.lang.Throwable;

    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem criarAnexo(
        javax.portlet.PortletRequest req)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Metodo responsavel por atualizar os anexos na base de dados.
    */
    public void atualizaAnexos(
        java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> anexos)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Metodo responsavel por remover os anexos de uma mensagem.
    */
    public void removeAnexos(
        java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> anexos)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Metodo responsavel em recuperar todos anexos de uma mensagem.
    *
    * @param mensagemId - identificado da mensagem.
    * @return List<AnexoMensagem> - retorna uma lista de anexos.
    * @throws SystemException - Em caso de falha.
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> recuperaAnexosPorMensagem(
        long mensagemId)
        throws com.liferay.portal.kernel.exception.SystemException;
}
