package br.mp.mprj.portal.portlet.gestaomensagens.service.service;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.util.ReferenceRegistry;
import com.liferay.portal.service.InvokableLocalService;

/**
 * Provides the local service utility for Mensagem. This utility wraps
 * {@link br.mp.mprj.portal.portlet.gestaomensagens.service.service.impl.MensagemLocalServiceImpl} and is the
 * primary access point for service operations in application layer code running
 * on the local server. Methods of this service will not have security checks
 * based on the propagated JAAS credentials because this service can only be
 * accessed from within the same VM.
 *
 * @author Henrique Simoes
 * @see MensagemLocalService
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.service.base.MensagemLocalServiceBaseImpl
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.service.impl.MensagemLocalServiceImpl
 * @generated
 */
public class MensagemLocalServiceUtil {
    private static MensagemLocalService _service;

    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify this class directly. Add custom service methods to {@link br.mp.mprj.portal.portlet.gestaomensagens.service.service.impl.MensagemLocalServiceImpl} and rerun ServiceBuilder to regenerate this class.
     */

    /**
    * Adds the mensagem to the database. Also notifies the appropriate model listeners.
    *
    * @param mensagem the mensagem
    * @return the mensagem that was added
    * @throws SystemException if a system exception occurred
    */
    public static br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem addMensagem(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem mensagem)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getService().addMensagem(mensagem);
    }

    /**
    * Creates a new mensagem with the primary key. Does not add the mensagem to the database.
    *
    * @param mensagemId the primary key for the new mensagem
    * @return the new mensagem
    */
    public static br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem createMensagem(
        long mensagemId) {
        return getService().createMensagem(mensagemId);
    }

    /**
    * Deletes the mensagem with the primary key from the database. Also notifies the appropriate model listeners.
    *
    * @param mensagemId the primary key of the mensagem
    * @return the mensagem that was removed
    * @throws PortalException if a mensagem with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public static br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem deleteMensagem(
        long mensagemId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return getService().deleteMensagem(mensagemId);
    }

    /**
    * Deletes the mensagem from the database. Also notifies the appropriate model listeners.
    *
    * @param mensagem the mensagem
    * @return the mensagem that was removed
    * @throws SystemException if a system exception occurred
    */
    public static br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem deleteMensagem(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem mensagem)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getService().deleteMensagem(mensagem);
    }

    public static com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery() {
        return getService().dynamicQuery();
    }

    /**
    * Performs a dynamic query on the database and returns the matching rows.
    *
    * @param dynamicQuery the dynamic query
    * @return the matching rows
    * @throws SystemException if a system exception occurred
    */
    @SuppressWarnings("rawtypes")
    public static java.util.List dynamicQuery(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getService().dynamicQuery(dynamicQuery);
    }

    /**
    * Performs a dynamic query on the database and returns a range of the matching rows.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.MensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param dynamicQuery the dynamic query
    * @param start the lower bound of the range of model instances
    * @param end the upper bound of the range of model instances (not inclusive)
    * @return the range of matching rows
    * @throws SystemException if a system exception occurred
    */
    @SuppressWarnings("rawtypes")
    public static java.util.List dynamicQuery(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
        int end) throws com.liferay.portal.kernel.exception.SystemException {
        return getService().dynamicQuery(dynamicQuery, start, end);
    }

    /**
    * Performs a dynamic query on the database and returns an ordered range of the matching rows.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.MensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param dynamicQuery the dynamic query
    * @param start the lower bound of the range of model instances
    * @param end the upper bound of the range of model instances (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching rows
    * @throws SystemException if a system exception occurred
    */
    @SuppressWarnings("rawtypes")
    public static java.util.List dynamicQuery(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
        int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getService()
                   .dynamicQuery(dynamicQuery, start, end, orderByComparator);
    }

    /**
    * Returns the number of rows that match the dynamic query.
    *
    * @param dynamicQuery the dynamic query
    * @return the number of rows that match the dynamic query
    * @throws SystemException if a system exception occurred
    */
    public static long dynamicQueryCount(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getService().dynamicQueryCount(dynamicQuery);
    }

    /**
    * Returns the number of rows that match the dynamic query.
    *
    * @param dynamicQuery the dynamic query
    * @param projection the projection to apply to the query
    * @return the number of rows that match the dynamic query
    * @throws SystemException if a system exception occurred
    */
    public static long dynamicQueryCount(
        com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery,
        com.liferay.portal.kernel.dao.orm.Projection projection)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getService().dynamicQueryCount(dynamicQuery, projection);
    }

    public static br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem fetchMensagem(
        long mensagemId)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getService().fetchMensagem(mensagemId);
    }

    /**
    * Returns the mensagem with the matching UUID and company.
    *
    * @param uuid the mensagem's UUID
    * @param companyId the primary key of the company
    * @return the matching mensagem, or <code>null</code> if a matching mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public static br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem fetchMensagemByUuidAndCompanyId(
        java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getService().fetchMensagemByUuidAndCompanyId(uuid, companyId);
    }

    /**
    * Returns the mensagem matching the UUID and group.
    *
    * @param uuid the mensagem's UUID
    * @param groupId the primary key of the group
    * @return the matching mensagem, or <code>null</code> if a matching mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public static br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem fetchMensagemByUuidAndGroupId(
        java.lang.String uuid, long groupId)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getService().fetchMensagemByUuidAndGroupId(uuid, groupId);
    }

    /**
    * Returns the mensagem with the primary key.
    *
    * @param mensagemId the primary key of the mensagem
    * @return the mensagem
    * @throws PortalException if a mensagem with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public static br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem getMensagem(
        long mensagemId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return getService().getMensagem(mensagemId);
    }

    public static com.liferay.portal.model.PersistedModel getPersistedModel(
        java.io.Serializable primaryKeyObj)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return getService().getPersistedModel(primaryKeyObj);
    }

    /**
    * Returns the mensagem with the matching UUID and company.
    *
    * @param uuid the mensagem's UUID
    * @param companyId the primary key of the company
    * @return the matching mensagem
    * @throws PortalException if a matching mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public static br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem getMensagemByUuidAndCompanyId(
        java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return getService().getMensagemByUuidAndCompanyId(uuid, companyId);
    }

    /**
    * Returns the mensagem matching the UUID and group.
    *
    * @param uuid the mensagem's UUID
    * @param groupId the primary key of the group
    * @return the matching mensagem
    * @throws PortalException if a matching mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public static br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem getMensagemByUuidAndGroupId(
        java.lang.String uuid, long groupId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return getService().getMensagemByUuidAndGroupId(uuid, groupId);
    }

    /**
    * Returns a range of all the mensagems.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.MensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param start the lower bound of the range of mensagems
    * @param end the upper bound of the range of mensagems (not inclusive)
    * @return the range of mensagems
    * @throws SystemException if a system exception occurred
    */
    public static java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem> getMensagems(
        int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getService().getMensagems(start, end);
    }

    /**
    * Returns the number of mensagems.
    *
    * @return the number of mensagems
    * @throws SystemException if a system exception occurred
    */
    public static int getMensagemsCount()
        throws com.liferay.portal.kernel.exception.SystemException {
        return getService().getMensagemsCount();
    }

    /**
    * Updates the mensagem in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
    *
    * @param mensagem the mensagem
    * @return the mensagem that was updated
    * @throws SystemException if a system exception occurred
    */
    public static br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem updateMensagem(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem mensagem)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getService().updateMensagem(mensagem);
    }

    /**
    * Returns the Spring bean ID for this bean.
    *
    * @return the Spring bean ID for this bean
    */
    public static java.lang.String getBeanIdentifier() {
        return getService().getBeanIdentifier();
    }

    /**
    * Sets the Spring bean ID for this bean.
    *
    * @param beanIdentifier the Spring bean ID for this bean
    */
    public static void setBeanIdentifier(java.lang.String beanIdentifier) {
        getService().setBeanIdentifier(beanIdentifier);
    }

    public static java.lang.Object invokeMethod(java.lang.String name,
        java.lang.String[] parameterTypes, java.lang.Object[] arguments)
        throws java.lang.Throwable {
        return getService().invokeMethod(name, parameterTypes, arguments);
    }

    /**
    * Retorna a mensagem de rascunho do usuario criador informado.
    *
    * @param userIdCriador
    * @return {@link Mensagem}
    * @throws PortalException
    * @throws SystemException
    */
    public static br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem getRascunho(
        long userIdCriador)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return getService().getRascunho(userIdCriador);
    }

    /**
    * Tenta recuperar a mensagem de rascunho, caso nao exista, tenta recuperar a mensagem da sessao.
    */
    public static br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem getMensagem(
        com.liferay.portal.kernel.upload.UploadPortletRequest uploadReq,
        javax.portlet.PortletRequest req)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return getService().getMensagem(uploadReq, req);
    }

    /**
    * Tenta recuperar a mensagem de rascunho, caso nao exista, tenta recuperar a mensagem da sessao.
    */
    public static br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem getMensagem(
        javax.portlet.PortletRequest req)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return getService().getMensagem(req);
    }

    /**
    * Retorna se est&aacute; no modo wizard rascunho, ou se est&aacute;
    * editando alguma mensagem previamente gravada (geralmente voltando ao fluxo de aprova&ccedil;&atilde;o).
    */
    public static boolean isRascunho(javax.portlet.PortletRequest req) {
        return getService().isRascunho(req);
    }

    /**
    * Metodo responsavel pelo cancelamento de todos os seus agendamentos pendentes da mensagem.
    */
    public static void cancelarMensagem(long mensagemId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        getService().cancelarMensagem(mensagemId);
    }

    /**
    * Metodo responsavel pela clonagem de uma mensagem existente
    * e todos os seus agendamentos pendentes.
    */
    public static br.mp.mprj.portal.portlet.gestaomensagens.service.model.Mensagem clonaMensagem(
        long mensagemId, javax.portlet.PortletRequest req)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return getService().clonaMensagem(mensagemId, req);
    }

    public static void clearService() {
        _service = null;
    }

    public static MensagemLocalService getService() {
        if (_service == null) {
            InvokableLocalService invokableLocalService = (InvokableLocalService) PortletBeanLocatorUtil.locate(ClpSerializer.getServletContextName(),
                    MensagemLocalService.class.getName());

            if (invokableLocalService instanceof MensagemLocalService) {
                _service = (MensagemLocalService) invokableLocalService;
            } else {
                _service = new MensagemLocalServiceClp(invokableLocalService);
            }

            ReferenceRegistry.registerReference(MensagemLocalServiceUtil.class,
                "_service");
        }

        return _service;
    }

    /**
     * @deprecated As of 6.2.0
     */
    public void setService(MensagemLocalService service) {
    }
}
