package br.mp.mprj.portal.portlet.gestaomensagens.service.service.http;

import br.mp.mprj.portal.portlet.gestaomensagens.service.service.GrupoDestinatarioServiceUtil;

import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;

import java.rmi.RemoteException;

/**
 * Provides the SOAP utility for the
 * {@link br.mp.mprj.portal.portlet.gestaomensagens.service.service.GrupoDestinatarioServiceUtil} service utility. The
 * static methods of this class calls the same methods of the service utility.
 * However, the signatures are different because it is difficult for SOAP to
 * support certain types.
 *
 * <p>
 * ServiceBuilder follows certain rules in translating the methods. For example,
 * if the method in the service utility returns a {@link java.util.List}, that
 * is translated to an array of {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.GrupoDestinatarioSoap}.
 * If the method in the service utility returns a
 * {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.GrupoDestinatario}, that is translated to a
 * {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.GrupoDestinatarioSoap}. Methods that SOAP cannot
 * safely wire are skipped.
 * </p>
 *
 * <p>
 * The benefits of using the SOAP utility is that it is cross platform
 * compatible. SOAP allows different languages like Java, .NET, C++, PHP, and
 * even Perl, to call the generated services. One drawback of SOAP is that it is
 * slow because it needs to serialize all calls into a text format (XML).
 * </p>
 *
 * <p>
 * You can see a list of services at http://localhost:8080/api/axis. Set the
 * property <b>axis.servlet.hosts.allowed</b> in portal.properties to configure
 * security.
 * </p>
 *
 * <p>
 * The SOAP utility is only generated for remote services.
 * </p>
 *
 * @author Henrique Simoes
 * @see GrupoDestinatarioServiceHttp
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.model.GrupoDestinatarioSoap
 * @see br.mp.mprj.portal.portlet.gestaomensagens.service.service.GrupoDestinatarioServiceUtil
 * @generated
 */
public class GrupoDestinatarioServiceSoap {
    private static Log _log = LogFactoryUtil.getLog(GrupoDestinatarioServiceSoap.class);

    public static br.mp.mprj.portal.portlet.gestaomensagens.ws.vo.CodigoDescricaoRetorno getListaDestinatario(
        java.lang.String nomeLista) throws RemoteException {
        try {
            br.mp.mprj.portal.portlet.gestaomensagens.ws.vo.CodigoDescricaoRetorno returnValue =
                GrupoDestinatarioServiceUtil.getListaDestinatario(nomeLista);

            return returnValue;
        } catch (Exception e) {
            _log.error(e, e);

            throw new RemoteException(e.getMessage());
        }
    }

    public static br.mp.mprj.portal.portlet.gestaomensagens.ws.vo.CodigoDescricaoRetorno getContaEnvio(
        java.lang.String nomeContaEnvio) throws RemoteException {
        try {
            br.mp.mprj.portal.portlet.gestaomensagens.ws.vo.CodigoDescricaoRetorno returnValue =
                GrupoDestinatarioServiceUtil.getContaEnvio(nomeContaEnvio);

            return returnValue;
        } catch (Exception e) {
            _log.error(e, e);

            throw new RemoteException(e.getMessage());
        }
    }
}
