package br.mp.mprj.portal.portlet.gestaomensagens.service.service.persistence;

import br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento;

import com.liferay.portal.service.persistence.BasePersistence;

/**
 * The persistence interface for the agendamento service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Henrique Simoes
 * @see AgendamentoPersistenceImpl
 * @see AgendamentoUtil
 * @generated
 */
public interface AgendamentoPersistence extends BasePersistence<Agendamento> {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this interface directly. Always use {@link AgendamentoUtil} to access the agendamento persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this interface.
     */

    /**
    * Returns all the agendamentos where uuid = &#63;.
    *
    * @param uuid the uuid
    * @return the matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByUuid(
        java.lang.String uuid)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the agendamentos where uuid = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param uuid the uuid
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @return the range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByUuid(
        java.lang.String uuid, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the agendamentos where uuid = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param uuid the uuid
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByUuid(
        java.lang.String uuid, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where uuid = &#63;.
    *
    * @param uuid the uuid
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByUuid_First(
        java.lang.String uuid,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where uuid = &#63;.
    *
    * @param uuid the uuid
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByUuid_First(
        java.lang.String uuid,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where uuid = &#63;.
    *
    * @param uuid the uuid
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByUuid_Last(
        java.lang.String uuid,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where uuid = &#63;.
    *
    * @param uuid the uuid
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByUuid_Last(
        java.lang.String uuid,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the agendamentos before and after the current agendamento in the ordered set where uuid = &#63;.
    *
    * @param agendamentoId the primary key of the current agendamento
    * @param uuid the uuid
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the previous, current, and next agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a agendamento with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento[] findByUuid_PrevAndNext(
        long agendamentoId, java.lang.String uuid,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the agendamentos where uuid = &#63; from the database.
    *
    * @param uuid the uuid
    * @throws SystemException if a system exception occurred
    */
    public void removeByUuid(java.lang.String uuid)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of agendamentos where uuid = &#63;.
    *
    * @param uuid the uuid
    * @return the number of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public int countByUuid(java.lang.String uuid)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the agendamento where uuid = &#63; and groupId = &#63; or throws a {@link br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException} if it could not be found.
    *
    * @param uuid the uuid
    * @param groupId the group ID
    * @return the matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByUUID_G(
        java.lang.String uuid, long groupId)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the agendamento where uuid = &#63; and groupId = &#63; or returns <code>null</code> if it could not be found. Uses the finder cache.
    *
    * @param uuid the uuid
    * @param groupId the group ID
    * @return the matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByUUID_G(
        java.lang.String uuid, long groupId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the agendamento where uuid = &#63; and groupId = &#63; or returns <code>null</code> if it could not be found, optionally using the finder cache.
    *
    * @param uuid the uuid
    * @param groupId the group ID
    * @param retrieveFromCache whether to use the finder cache
    * @return the matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByUUID_G(
        java.lang.String uuid, long groupId, boolean retrieveFromCache)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes the agendamento where uuid = &#63; and groupId = &#63; from the database.
    *
    * @param uuid the uuid
    * @param groupId the group ID
    * @return the agendamento that was removed
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento removeByUUID_G(
        java.lang.String uuid, long groupId)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of agendamentos where uuid = &#63; and groupId = &#63;.
    *
    * @param uuid the uuid
    * @param groupId the group ID
    * @return the number of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public int countByUUID_G(java.lang.String uuid, long groupId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the agendamentos where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @return the matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByUuid_C(
        java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the agendamentos where uuid = &#63; and companyId = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @return the range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByUuid_C(
        java.lang.String uuid, long companyId, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the agendamentos where uuid = &#63; and companyId = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByUuid_C(
        java.lang.String uuid, long companyId, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByUuid_C_First(
        java.lang.String uuid, long companyId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByUuid_C_First(
        java.lang.String uuid, long companyId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByUuid_C_Last(
        java.lang.String uuid, long companyId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByUuid_C_Last(
        java.lang.String uuid, long companyId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the agendamentos before and after the current agendamento in the ordered set where uuid = &#63; and companyId = &#63;.
    *
    * @param agendamentoId the primary key of the current agendamento
    * @param uuid the uuid
    * @param companyId the company ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the previous, current, and next agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a agendamento with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento[] findByUuid_C_PrevAndNext(
        long agendamentoId, java.lang.String uuid, long companyId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the agendamentos where uuid = &#63; and companyId = &#63; from the database.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @throws SystemException if a system exception occurred
    */
    public void removeByUuid_C(java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of agendamentos where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @return the number of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public int countByUuid_C(java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the agendamentos where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @return the matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemTipo(
        long mensagemId, int tipoAgendamento)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the agendamentos where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @return the range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemTipo(
        long mensagemId, int tipoAgendamento, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the agendamentos where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemTipo(
        long mensagemId, int tipoAgendamento, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByMensagemTipo_First(
        long mensagemId, int tipoAgendamento,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByMensagemTipo_First(
        long mensagemId, int tipoAgendamento,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByMensagemTipo_Last(
        long mensagemId, int tipoAgendamento,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByMensagemTipo_Last(
        long mensagemId, int tipoAgendamento,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the agendamentos before and after the current agendamento in the ordered set where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * @param agendamentoId the primary key of the current agendamento
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the previous, current, and next agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a agendamento with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento[] findByMensagemTipo_PrevAndNext(
        long agendamentoId, long mensagemId, int tipoAgendamento,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the agendamentos where mensagemId = &#63; and tipoAgendamento = &#63; from the database.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @throws SystemException if a system exception occurred
    */
    public void removeByMensagemTipo(long mensagemId, int tipoAgendamento)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of agendamentos where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @return the number of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public int countByMensagemTipo(long mensagemId, int tipoAgendamento)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the agendamentos where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @return the matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemTipoMultipo(
        long mensagemId, int tipoAgendamento)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the agendamentos where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @return the range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemTipoMultipo(
        long mensagemId, int tipoAgendamento, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the agendamentos where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemTipoMultipo(
        long mensagemId, int tipoAgendamento, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByMensagemTipoMultipo_First(
        long mensagemId, int tipoAgendamento,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByMensagemTipoMultipo_First(
        long mensagemId, int tipoAgendamento,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByMensagemTipoMultipo_Last(
        long mensagemId, int tipoAgendamento,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByMensagemTipoMultipo_Last(
        long mensagemId, int tipoAgendamento,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the agendamentos before and after the current agendamento in the ordered set where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * @param agendamentoId the primary key of the current agendamento
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the previous, current, and next agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a agendamento with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento[] findByMensagemTipoMultipo_PrevAndNext(
        long agendamentoId, long mensagemId, int tipoAgendamento,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the agendamentos where mensagemId = &#63; and tipoAgendamento = any &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamentos the tipo agendamentos
    * @return the matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemTipoMultipo(
        long mensagemId, int[] tipoAgendamentos)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the agendamentos where mensagemId = &#63; and tipoAgendamento = any &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamentos the tipo agendamentos
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @return the range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemTipoMultipo(
        long mensagemId, int[] tipoAgendamentos, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the agendamentos where mensagemId = &#63; and tipoAgendamento = any &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamentos the tipo agendamentos
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemTipoMultipo(
        long mensagemId, int[] tipoAgendamentos, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the agendamentos where mensagemId = &#63; and tipoAgendamento = &#63; from the database.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @throws SystemException if a system exception occurred
    */
    public void removeByMensagemTipoMultipo(long mensagemId, int tipoAgendamento)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of agendamentos where mensagemId = &#63; and tipoAgendamento = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @return the number of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public int countByMensagemTipoMultipo(long mensagemId, int tipoAgendamento)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of agendamentos where mensagemId = &#63; and tipoAgendamento = any &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamentos the tipo agendamentos
    * @return the number of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public int countByMensagemTipoMultipo(long mensagemId,
        int[] tipoAgendamentos)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the agendamentos where mensagemId = &#63; and dataCalendario = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param dataCalendario the data calendario
    * @return the matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemDataCalendario(
        long mensagemId, java.util.Date dataCalendario)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the agendamentos where mensagemId = &#63; and dataCalendario = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param dataCalendario the data calendario
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @return the range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemDataCalendario(
        long mensagemId, java.util.Date dataCalendario, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the agendamentos where mensagemId = &#63; and dataCalendario = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param dataCalendario the data calendario
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemDataCalendario(
        long mensagemId, java.util.Date dataCalendario, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where mensagemId = &#63; and dataCalendario = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param dataCalendario the data calendario
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByMensagemDataCalendario_First(
        long mensagemId, java.util.Date dataCalendario,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where mensagemId = &#63; and dataCalendario = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param dataCalendario the data calendario
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByMensagemDataCalendario_First(
        long mensagemId, java.util.Date dataCalendario,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where mensagemId = &#63; and dataCalendario = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param dataCalendario the data calendario
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByMensagemDataCalendario_Last(
        long mensagemId, java.util.Date dataCalendario,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where mensagemId = &#63; and dataCalendario = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param dataCalendario the data calendario
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByMensagemDataCalendario_Last(
        long mensagemId, java.util.Date dataCalendario,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the agendamentos before and after the current agendamento in the ordered set where mensagemId = &#63; and dataCalendario = &#63;.
    *
    * @param agendamentoId the primary key of the current agendamento
    * @param mensagemId the mensagem ID
    * @param dataCalendario the data calendario
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the previous, current, and next agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a agendamento with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento[] findByMensagemDataCalendario_PrevAndNext(
        long agendamentoId, long mensagemId, java.util.Date dataCalendario,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the agendamentos where mensagemId = &#63; and dataCalendario = &#63; from the database.
    *
    * @param mensagemId the mensagem ID
    * @param dataCalendario the data calendario
    * @throws SystemException if a system exception occurred
    */
    public void removeByMensagemDataCalendario(long mensagemId,
        java.util.Date dataCalendario)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of agendamentos where mensagemId = &#63; and dataCalendario = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param dataCalendario the data calendario
    * @return the number of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public int countByMensagemDataCalendario(long mensagemId,
        java.util.Date dataCalendario)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the agendamentos where situacaoEnvio = &#63;.
    *
    * @param situacaoEnvio the situacao envio
    * @return the matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findBySituacao(
        int situacaoEnvio)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the agendamentos where situacaoEnvio = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param situacaoEnvio the situacao envio
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @return the range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findBySituacao(
        int situacaoEnvio, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the agendamentos where situacaoEnvio = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param situacaoEnvio the situacao envio
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findBySituacao(
        int situacaoEnvio, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where situacaoEnvio = &#63;.
    *
    * @param situacaoEnvio the situacao envio
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findBySituacao_First(
        int situacaoEnvio,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where situacaoEnvio = &#63;.
    *
    * @param situacaoEnvio the situacao envio
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchBySituacao_First(
        int situacaoEnvio,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where situacaoEnvio = &#63;.
    *
    * @param situacaoEnvio the situacao envio
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findBySituacao_Last(
        int situacaoEnvio,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where situacaoEnvio = &#63;.
    *
    * @param situacaoEnvio the situacao envio
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchBySituacao_Last(
        int situacaoEnvio,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the agendamentos before and after the current agendamento in the ordered set where situacaoEnvio = &#63;.
    *
    * @param agendamentoId the primary key of the current agendamento
    * @param situacaoEnvio the situacao envio
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the previous, current, and next agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a agendamento with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento[] findBySituacao_PrevAndNext(
        long agendamentoId, int situacaoEnvio,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the agendamentos where situacaoEnvio = &#63; from the database.
    *
    * @param situacaoEnvio the situacao envio
    * @throws SystemException if a system exception occurred
    */
    public void removeBySituacao(int situacaoEnvio)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of agendamentos where situacaoEnvio = &#63;.
    *
    * @param situacaoEnvio the situacao envio
    * @return the number of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public int countBySituacao(int situacaoEnvio)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the agendamentos where situacaoEnvio = &#63; and mensagemId = &#63;.
    *
    * @param situacaoEnvio the situacao envio
    * @param mensagemId the mensagem ID
    * @return the matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findBySituacaoMensagem(
        int situacaoEnvio, long mensagemId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the agendamentos where situacaoEnvio = &#63; and mensagemId = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param situacaoEnvio the situacao envio
    * @param mensagemId the mensagem ID
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @return the range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findBySituacaoMensagem(
        int situacaoEnvio, long mensagemId, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the agendamentos where situacaoEnvio = &#63; and mensagemId = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param situacaoEnvio the situacao envio
    * @param mensagemId the mensagem ID
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findBySituacaoMensagem(
        int situacaoEnvio, long mensagemId, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where situacaoEnvio = &#63; and mensagemId = &#63;.
    *
    * @param situacaoEnvio the situacao envio
    * @param mensagemId the mensagem ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findBySituacaoMensagem_First(
        int situacaoEnvio, long mensagemId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where situacaoEnvio = &#63; and mensagemId = &#63;.
    *
    * @param situacaoEnvio the situacao envio
    * @param mensagemId the mensagem ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchBySituacaoMensagem_First(
        int situacaoEnvio, long mensagemId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where situacaoEnvio = &#63; and mensagemId = &#63;.
    *
    * @param situacaoEnvio the situacao envio
    * @param mensagemId the mensagem ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findBySituacaoMensagem_Last(
        int situacaoEnvio, long mensagemId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where situacaoEnvio = &#63; and mensagemId = &#63;.
    *
    * @param situacaoEnvio the situacao envio
    * @param mensagemId the mensagem ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchBySituacaoMensagem_Last(
        int situacaoEnvio, long mensagemId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the agendamentos before and after the current agendamento in the ordered set where situacaoEnvio = &#63; and mensagemId = &#63;.
    *
    * @param agendamentoId the primary key of the current agendamento
    * @param situacaoEnvio the situacao envio
    * @param mensagemId the mensagem ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the previous, current, and next agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a agendamento with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento[] findBySituacaoMensagem_PrevAndNext(
        long agendamentoId, int situacaoEnvio, long mensagemId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the agendamentos where situacaoEnvio = &#63; and mensagemId = &#63; from the database.
    *
    * @param situacaoEnvio the situacao envio
    * @param mensagemId the mensagem ID
    * @throws SystemException if a system exception occurred
    */
    public void removeBySituacaoMensagem(int situacaoEnvio, long mensagemId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of agendamentos where situacaoEnvio = &#63; and mensagemId = &#63;.
    *
    * @param situacaoEnvio the situacao envio
    * @param mensagemId the mensagem ID
    * @return the number of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public int countBySituacaoMensagem(int situacaoEnvio, long mensagemId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the agendamentos where mensagemId = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @return the matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemId(
        long mensagemId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the agendamentos where mensagemId = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @return the range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemId(
        long mensagemId, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the agendamentos where mensagemId = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemId(
        long mensagemId, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where mensagemId = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByMensagemId_First(
        long mensagemId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where mensagemId = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByMensagemId_First(
        long mensagemId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where mensagemId = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByMensagemId_Last(
        long mensagemId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where mensagemId = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByMensagemId_Last(
        long mensagemId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the agendamentos before and after the current agendamento in the ordered set where mensagemId = &#63;.
    *
    * @param agendamentoId the primary key of the current agendamento
    * @param mensagemId the mensagem ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the previous, current, and next agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a agendamento with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento[] findByMensagemId_PrevAndNext(
        long agendamentoId, long mensagemId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the agendamentos where mensagemId = &#63; from the database.
    *
    * @param mensagemId the mensagem ID
    * @throws SystemException if a system exception occurred
    */
    public void removeByMensagemId(long mensagemId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of agendamentos where mensagemId = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @return the number of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public int countByMensagemId(long mensagemId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the agendamentos where mensagemId = &#63; and situacaoEnvio = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param situacaoEnvio the situacao envio
    * @return the matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemIdSituacaoEnvio(
        long mensagemId, int situacaoEnvio)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the agendamentos where mensagemId = &#63; and situacaoEnvio = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param situacaoEnvio the situacao envio
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @return the range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemIdSituacaoEnvio(
        long mensagemId, int situacaoEnvio, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the agendamentos where mensagemId = &#63; and situacaoEnvio = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param situacaoEnvio the situacao envio
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByMensagemIdSituacaoEnvio(
        long mensagemId, int situacaoEnvio, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where mensagemId = &#63; and situacaoEnvio = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param situacaoEnvio the situacao envio
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByMensagemIdSituacaoEnvio_First(
        long mensagemId, int situacaoEnvio,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where mensagemId = &#63; and situacaoEnvio = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param situacaoEnvio the situacao envio
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByMensagemIdSituacaoEnvio_First(
        long mensagemId, int situacaoEnvio,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where mensagemId = &#63; and situacaoEnvio = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param situacaoEnvio the situacao envio
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByMensagemIdSituacaoEnvio_Last(
        long mensagemId, int situacaoEnvio,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where mensagemId = &#63; and situacaoEnvio = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param situacaoEnvio the situacao envio
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByMensagemIdSituacaoEnvio_Last(
        long mensagemId, int situacaoEnvio,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the agendamentos before and after the current agendamento in the ordered set where mensagemId = &#63; and situacaoEnvio = &#63;.
    *
    * @param agendamentoId the primary key of the current agendamento
    * @param mensagemId the mensagem ID
    * @param situacaoEnvio the situacao envio
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the previous, current, and next agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a agendamento with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento[] findByMensagemIdSituacaoEnvio_PrevAndNext(
        long agendamentoId, long mensagemId, int situacaoEnvio,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the agendamentos where mensagemId = &#63; and situacaoEnvio = &#63; from the database.
    *
    * @param mensagemId the mensagem ID
    * @param situacaoEnvio the situacao envio
    * @throws SystemException if a system exception occurred
    */
    public void removeByMensagemIdSituacaoEnvio(long mensagemId,
        int situacaoEnvio)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of agendamentos where mensagemId = &#63; and situacaoEnvio = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param situacaoEnvio the situacao envio
    * @return the number of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public int countByMensagemIdSituacaoEnvio(long mensagemId, int situacaoEnvio)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the agendamentos where mensagemId = &#63; and tipoAgendamento = &#63; and situacaoEnvio = &#63; and agendamentoId &ne; &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param situacaoEnvio the situacao envio
    * @param agendamentoId the agendamento ID
    * @return the matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByAgendamentoExclusao(
        long mensagemId, int tipoAgendamento, int situacaoEnvio,
        long agendamentoId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the agendamentos where mensagemId = &#63; and tipoAgendamento = &#63; and situacaoEnvio = &#63; and agendamentoId &ne; &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param situacaoEnvio the situacao envio
    * @param agendamentoId the agendamento ID
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @return the range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByAgendamentoExclusao(
        long mensagemId, int tipoAgendamento, int situacaoEnvio,
        long agendamentoId, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the agendamentos where mensagemId = &#63; and tipoAgendamento = &#63; and situacaoEnvio = &#63; and agendamentoId &ne; &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param situacaoEnvio the situacao envio
    * @param agendamentoId the agendamento ID
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByAgendamentoExclusao(
        long mensagemId, int tipoAgendamento, int situacaoEnvio,
        long agendamentoId, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where mensagemId = &#63; and tipoAgendamento = &#63; and situacaoEnvio = &#63; and agendamentoId &ne; &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param situacaoEnvio the situacao envio
    * @param agendamentoId the agendamento ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByAgendamentoExclusao_First(
        long mensagemId, int tipoAgendamento, int situacaoEnvio,
        long agendamentoId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first agendamento in the ordered set where mensagemId = &#63; and tipoAgendamento = &#63; and situacaoEnvio = &#63; and agendamentoId &ne; &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param situacaoEnvio the situacao envio
    * @param agendamentoId the agendamento ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByAgendamentoExclusao_First(
        long mensagemId, int tipoAgendamento, int situacaoEnvio,
        long agendamentoId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where mensagemId = &#63; and tipoAgendamento = &#63; and situacaoEnvio = &#63; and agendamentoId &ne; &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param situacaoEnvio the situacao envio
    * @param agendamentoId the agendamento ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByAgendamentoExclusao_Last(
        long mensagemId, int tipoAgendamento, int situacaoEnvio,
        long agendamentoId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last agendamento in the ordered set where mensagemId = &#63; and tipoAgendamento = &#63; and situacaoEnvio = &#63; and agendamentoId &ne; &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param situacaoEnvio the situacao envio
    * @param agendamentoId the agendamento ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching agendamento, or <code>null</code> if a matching agendamento could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByAgendamentoExclusao_Last(
        long mensagemId, int tipoAgendamento, int situacaoEnvio,
        long agendamentoId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the agendamentos where mensagemId = &#63; and tipoAgendamento = any &#63; and situacaoEnvio = &#63; and agendamentoId &ne; all &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamentos the tipo agendamentos
    * @param situacaoEnvio the situacao envio
    * @param agendamentoIds the agendamento IDs
    * @return the matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByAgendamentoExclusao(
        long mensagemId, int[] tipoAgendamentos, int situacaoEnvio,
        long[] agendamentoIds)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the agendamentos where mensagemId = &#63; and tipoAgendamento = any &#63; and situacaoEnvio = &#63; and agendamentoId &ne; all &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamentos the tipo agendamentos
    * @param situacaoEnvio the situacao envio
    * @param agendamentoIds the agendamento IDs
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @return the range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByAgendamentoExclusao(
        long mensagemId, int[] tipoAgendamentos, int situacaoEnvio,
        long[] agendamentoIds, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the agendamentos where mensagemId = &#63; and tipoAgendamento = any &#63; and situacaoEnvio = &#63; and agendamentoId &ne; all &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamentos the tipo agendamentos
    * @param situacaoEnvio the situacao envio
    * @param agendamentoIds the agendamento IDs
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findByAgendamentoExclusao(
        long mensagemId, int[] tipoAgendamentos, int situacaoEnvio,
        long[] agendamentoIds, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the agendamentos where mensagemId = &#63; and tipoAgendamento = &#63; and situacaoEnvio = &#63; and agendamentoId &ne; &#63; from the database.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param situacaoEnvio the situacao envio
    * @param agendamentoId the agendamento ID
    * @throws SystemException if a system exception occurred
    */
    public void removeByAgendamentoExclusao(long mensagemId,
        int tipoAgendamento, int situacaoEnvio, long agendamentoId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of agendamentos where mensagemId = &#63; and tipoAgendamento = &#63; and situacaoEnvio = &#63; and agendamentoId &ne; &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamento the tipo agendamento
    * @param situacaoEnvio the situacao envio
    * @param agendamentoId the agendamento ID
    * @return the number of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public int countByAgendamentoExclusao(long mensagemId, int tipoAgendamento,
        int situacaoEnvio, long agendamentoId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of agendamentos where mensagemId = &#63; and tipoAgendamento = any &#63; and situacaoEnvio = &#63; and agendamentoId &ne; all &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param tipoAgendamentos the tipo agendamentos
    * @param situacaoEnvio the situacao envio
    * @param agendamentoIds the agendamento IDs
    * @return the number of matching agendamentos
    * @throws SystemException if a system exception occurred
    */
    public int countByAgendamentoExclusao(long mensagemId,
        int[] tipoAgendamentos, int situacaoEnvio, long[] agendamentoIds)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Caches the agendamento in the entity cache if it is enabled.
    *
    * @param agendamento the agendamento
    */
    public void cacheResult(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento agendamento);

    /**
    * Caches the agendamentos in the entity cache if it is enabled.
    *
    * @param agendamentos the agendamentos
    */
    public void cacheResult(
        java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> agendamentos);

    /**
    * Creates a new agendamento with the primary key. Does not add the agendamento to the database.
    *
    * @param agendamentoId the primary key for the new agendamento
    * @return the new agendamento
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento create(
        long agendamentoId);

    /**
    * Removes the agendamento with the primary key from the database. Also notifies the appropriate model listeners.
    *
    * @param agendamentoId the primary key of the agendamento
    * @return the agendamento that was removed
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a agendamento with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento remove(
        long agendamentoId)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento updateImpl(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento agendamento)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the agendamento with the primary key or throws a {@link br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException} if it could not be found.
    *
    * @param agendamentoId the primary key of the agendamento
    * @return the agendamento
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException if a agendamento with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento findByPrimaryKey(
        long agendamentoId)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAgendamentoException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the agendamento with the primary key or returns <code>null</code> if it could not be found.
    *
    * @param agendamentoId the primary key of the agendamento
    * @return the agendamento, or <code>null</code> if a agendamento with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento fetchByPrimaryKey(
        long agendamentoId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the agendamentos.
    *
    * @return the agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findAll()
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the agendamentos.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @return the range of agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findAll(
        int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the agendamentos.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AgendamentoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param start the lower bound of the range of agendamentos
    * @param end the upper bound of the range of agendamentos (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of agendamentos
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Agendamento> findAll(
        int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the agendamentos from the database.
    *
    * @throws SystemException if a system exception occurred
    */
    public void removeAll()
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of agendamentos.
    *
    * @return the number of agendamentos
    * @throws SystemException if a system exception occurred
    */
    public int countAll()
        throws com.liferay.portal.kernel.exception.SystemException;
}
