package br.mp.mprj.portal.portlet.gestaomensagens.service.service.persistence;

import br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem;

import com.liferay.portal.service.persistence.BasePersistence;

/**
 * The persistence interface for the anexo mensagem service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Henrique Simoes
 * @see AnexoMensagemPersistenceImpl
 * @see AnexoMensagemUtil
 * @generated
 */
public interface AnexoMensagemPersistence extends BasePersistence<AnexoMensagem> {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this interface directly. Always use {@link AnexoMensagemUtil} to access the anexo mensagem persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this interface.
     */

    /**
    * Returns all the anexo mensagems where uuid = &#63;.
    *
    * @param uuid the uuid
    * @return the matching anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> findByUuid(
        java.lang.String uuid)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the anexo mensagems where uuid = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param uuid the uuid
    * @param start the lower bound of the range of anexo mensagems
    * @param end the upper bound of the range of anexo mensagems (not inclusive)
    * @return the range of matching anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> findByUuid(
        java.lang.String uuid, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the anexo mensagems where uuid = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param uuid the uuid
    * @param start the lower bound of the range of anexo mensagems
    * @param end the upper bound of the range of anexo mensagems (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> findByUuid(
        java.lang.String uuid, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first anexo mensagem in the ordered set where uuid = &#63;.
    *
    * @param uuid the uuid
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching anexo mensagem
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem findByUuid_First(
        java.lang.String uuid,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first anexo mensagem in the ordered set where uuid = &#63;.
    *
    * @param uuid the uuid
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem fetchByUuid_First(
        java.lang.String uuid,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last anexo mensagem in the ordered set where uuid = &#63;.
    *
    * @param uuid the uuid
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching anexo mensagem
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem findByUuid_Last(
        java.lang.String uuid,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last anexo mensagem in the ordered set where uuid = &#63;.
    *
    * @param uuid the uuid
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem fetchByUuid_Last(
        java.lang.String uuid,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the anexo mensagems before and after the current anexo mensagem in the ordered set where uuid = &#63;.
    *
    * @param anexoMensagemId the primary key of the current anexo mensagem
    * @param uuid the uuid
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the previous, current, and next anexo mensagem
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a anexo mensagem with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem[] findByUuid_PrevAndNext(
        long anexoMensagemId, java.lang.String uuid,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the anexo mensagems where uuid = &#63; from the database.
    *
    * @param uuid the uuid
    * @throws SystemException if a system exception occurred
    */
    public void removeByUuid(java.lang.String uuid)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of anexo mensagems where uuid = &#63;.
    *
    * @param uuid the uuid
    * @return the number of matching anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public int countByUuid(java.lang.String uuid)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the anexo mensagem where uuid = &#63; and groupId = &#63; or throws a {@link br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException} if it could not be found.
    *
    * @param uuid the uuid
    * @param groupId the group ID
    * @return the matching anexo mensagem
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem findByUUID_G(
        java.lang.String uuid, long groupId)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the anexo mensagem where uuid = &#63; and groupId = &#63; or returns <code>null</code> if it could not be found. Uses the finder cache.
    *
    * @param uuid the uuid
    * @param groupId the group ID
    * @return the matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem fetchByUUID_G(
        java.lang.String uuid, long groupId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the anexo mensagem where uuid = &#63; and groupId = &#63; or returns <code>null</code> if it could not be found, optionally using the finder cache.
    *
    * @param uuid the uuid
    * @param groupId the group ID
    * @param retrieveFromCache whether to use the finder cache
    * @return the matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem fetchByUUID_G(
        java.lang.String uuid, long groupId, boolean retrieveFromCache)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes the anexo mensagem where uuid = &#63; and groupId = &#63; from the database.
    *
    * @param uuid the uuid
    * @param groupId the group ID
    * @return the anexo mensagem that was removed
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem removeByUUID_G(
        java.lang.String uuid, long groupId)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of anexo mensagems where uuid = &#63; and groupId = &#63;.
    *
    * @param uuid the uuid
    * @param groupId the group ID
    * @return the number of matching anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public int countByUUID_G(java.lang.String uuid, long groupId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the anexo mensagems where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @return the matching anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> findByUuid_C(
        java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the anexo mensagems where uuid = &#63; and companyId = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param start the lower bound of the range of anexo mensagems
    * @param end the upper bound of the range of anexo mensagems (not inclusive)
    * @return the range of matching anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> findByUuid_C(
        java.lang.String uuid, long companyId, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the anexo mensagems where uuid = &#63; and companyId = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param start the lower bound of the range of anexo mensagems
    * @param end the upper bound of the range of anexo mensagems (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> findByUuid_C(
        java.lang.String uuid, long companyId, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first anexo mensagem in the ordered set where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching anexo mensagem
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem findByUuid_C_First(
        java.lang.String uuid, long companyId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first anexo mensagem in the ordered set where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem fetchByUuid_C_First(
        java.lang.String uuid, long companyId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last anexo mensagem in the ordered set where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching anexo mensagem
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem findByUuid_C_Last(
        java.lang.String uuid, long companyId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last anexo mensagem in the ordered set where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem fetchByUuid_C_Last(
        java.lang.String uuid, long companyId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the anexo mensagems before and after the current anexo mensagem in the ordered set where uuid = &#63; and companyId = &#63;.
    *
    * @param anexoMensagemId the primary key of the current anexo mensagem
    * @param uuid the uuid
    * @param companyId the company ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the previous, current, and next anexo mensagem
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a anexo mensagem with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem[] findByUuid_C_PrevAndNext(
        long anexoMensagemId, java.lang.String uuid, long companyId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the anexo mensagems where uuid = &#63; and companyId = &#63; from the database.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @throws SystemException if a system exception occurred
    */
    public void removeByUuid_C(java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of anexo mensagems where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @return the number of matching anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public int countByUuid_C(java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the anexo mensagems where mensagemId = &#63; and ativo = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param ativo the ativo
    * @return the matching anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> findByMensagemIdAtivo(
        long mensagemId, boolean ativo)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the anexo mensagems where mensagemId = &#63; and ativo = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param ativo the ativo
    * @param start the lower bound of the range of anexo mensagems
    * @param end the upper bound of the range of anexo mensagems (not inclusive)
    * @return the range of matching anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> findByMensagemIdAtivo(
        long mensagemId, boolean ativo, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the anexo mensagems where mensagemId = &#63; and ativo = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param mensagemId the mensagem ID
    * @param ativo the ativo
    * @param start the lower bound of the range of anexo mensagems
    * @param end the upper bound of the range of anexo mensagems (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> findByMensagemIdAtivo(
        long mensagemId, boolean ativo, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first anexo mensagem in the ordered set where mensagemId = &#63; and ativo = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param ativo the ativo
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching anexo mensagem
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem findByMensagemIdAtivo_First(
        long mensagemId, boolean ativo,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first anexo mensagem in the ordered set where mensagemId = &#63; and ativo = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param ativo the ativo
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem fetchByMensagemIdAtivo_First(
        long mensagemId, boolean ativo,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last anexo mensagem in the ordered set where mensagemId = &#63; and ativo = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param ativo the ativo
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching anexo mensagem
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem findByMensagemIdAtivo_Last(
        long mensagemId, boolean ativo,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last anexo mensagem in the ordered set where mensagemId = &#63; and ativo = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param ativo the ativo
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem fetchByMensagemIdAtivo_Last(
        long mensagemId, boolean ativo,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the anexo mensagems before and after the current anexo mensagem in the ordered set where mensagemId = &#63; and ativo = &#63;.
    *
    * @param anexoMensagemId the primary key of the current anexo mensagem
    * @param mensagemId the mensagem ID
    * @param ativo the ativo
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the previous, current, and next anexo mensagem
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a anexo mensagem with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem[] findByMensagemIdAtivo_PrevAndNext(
        long anexoMensagemId, long mensagemId, boolean ativo,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the anexo mensagems where mensagemId = &#63; and ativo = &#63; from the database.
    *
    * @param mensagemId the mensagem ID
    * @param ativo the ativo
    * @throws SystemException if a system exception occurred
    */
    public void removeByMensagemIdAtivo(long mensagemId, boolean ativo)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of anexo mensagems where mensagemId = &#63; and ativo = &#63;.
    *
    * @param mensagemId the mensagem ID
    * @param ativo the ativo
    * @return the number of matching anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public int countByMensagemIdAtivo(long mensagemId, boolean ativo)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Caches the anexo mensagem in the entity cache if it is enabled.
    *
    * @param anexoMensagem the anexo mensagem
    */
    public void cacheResult(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem anexoMensagem);

    /**
    * Caches the anexo mensagems in the entity cache if it is enabled.
    *
    * @param anexoMensagems the anexo mensagems
    */
    public void cacheResult(
        java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> anexoMensagems);

    /**
    * Creates a new anexo mensagem with the primary key. Does not add the anexo mensagem to the database.
    *
    * @param anexoMensagemId the primary key for the new anexo mensagem
    * @return the new anexo mensagem
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem create(
        long anexoMensagemId);

    /**
    * Removes the anexo mensagem with the primary key from the database. Also notifies the appropriate model listeners.
    *
    * @param anexoMensagemId the primary key of the anexo mensagem
    * @return the anexo mensagem that was removed
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a anexo mensagem with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem remove(
        long anexoMensagemId)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException,
            com.liferay.portal.kernel.exception.SystemException;

    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem updateImpl(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem anexoMensagem)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the anexo mensagem with the primary key or throws a {@link br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException} if it could not be found.
    *
    * @param anexoMensagemId the primary key of the anexo mensagem
    * @return the anexo mensagem
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a anexo mensagem with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem findByPrimaryKey(
        long anexoMensagemId)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the anexo mensagem with the primary key or returns <code>null</code> if it could not be found.
    *
    * @param anexoMensagemId the primary key of the anexo mensagem
    * @return the anexo mensagem, or <code>null</code> if a anexo mensagem with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem fetchByPrimaryKey(
        long anexoMensagemId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the anexo mensagems.
    *
    * @return the anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> findAll()
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the anexo mensagems.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param start the lower bound of the range of anexo mensagems
    * @param end the upper bound of the range of anexo mensagems (not inclusive)
    * @return the range of anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> findAll(
        int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the anexo mensagems.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param start the lower bound of the range of anexo mensagems
    * @param end the upper bound of the range of anexo mensagems (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem> findAll(
        int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the anexo mensagems from the database.
    *
    * @throws SystemException if a system exception occurred
    */
    public void removeAll()
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of anexo mensagems.
    *
    * @return the number of anexo mensagems
    * @throws SystemException if a system exception occurred
    */
    public int countAll()
        throws com.liferay.portal.kernel.exception.SystemException;
}
