package br.mp.mprj.portal.portlet.gestaomensagens.service.service.persistence;

import br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template;

import com.liferay.portal.service.persistence.BasePersistence;

/**
 * The persistence interface for the template service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Henrique Simoes
 * @see TemplatePersistenceImpl
 * @see TemplateUtil
 * @generated
 */
public interface TemplatePersistence extends BasePersistence<Template> {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this interface directly. Always use {@link TemplateUtil} to access the template persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this interface.
     */

    /**
    * Returns all the templates where uuid = &#63;.
    *
    * @param uuid the uuid
    * @return the matching templates
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template> findByUuid(
        java.lang.String uuid)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the templates where uuid = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param uuid the uuid
    * @param start the lower bound of the range of templates
    * @param end the upper bound of the range of templates (not inclusive)
    * @return the range of matching templates
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template> findByUuid(
        java.lang.String uuid, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the templates where uuid = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param uuid the uuid
    * @param start the lower bound of the range of templates
    * @param end the upper bound of the range of templates (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching templates
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template> findByUuid(
        java.lang.String uuid, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first template in the ordered set where uuid = &#63;.
    *
    * @param uuid the uuid
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching template
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template findByUuid_First(
        java.lang.String uuid,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first template in the ordered set where uuid = &#63;.
    *
    * @param uuid the uuid
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching template, or <code>null</code> if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template fetchByUuid_First(
        java.lang.String uuid,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last template in the ordered set where uuid = &#63;.
    *
    * @param uuid the uuid
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching template
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template findByUuid_Last(
        java.lang.String uuid,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last template in the ordered set where uuid = &#63;.
    *
    * @param uuid the uuid
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching template, or <code>null</code> if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template fetchByUuid_Last(
        java.lang.String uuid,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the templates before and after the current template in the ordered set where uuid = &#63;.
    *
    * @param templateId the primary key of the current template
    * @param uuid the uuid
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the previous, current, and next template
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a template with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template[] findByUuid_PrevAndNext(
        long templateId, java.lang.String uuid,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the templates where uuid = &#63; from the database.
    *
    * @param uuid the uuid
    * @throws SystemException if a system exception occurred
    */
    public void removeByUuid(java.lang.String uuid)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of templates where uuid = &#63;.
    *
    * @param uuid the uuid
    * @return the number of matching templates
    * @throws SystemException if a system exception occurred
    */
    public int countByUuid(java.lang.String uuid)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the template where uuid = &#63; and groupId = &#63; or throws a {@link br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException} if it could not be found.
    *
    * @param uuid the uuid
    * @param groupId the group ID
    * @return the matching template
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template findByUUID_G(
        java.lang.String uuid, long groupId)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the template where uuid = &#63; and groupId = &#63; or returns <code>null</code> if it could not be found. Uses the finder cache.
    *
    * @param uuid the uuid
    * @param groupId the group ID
    * @return the matching template, or <code>null</code> if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template fetchByUUID_G(
        java.lang.String uuid, long groupId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the template where uuid = &#63; and groupId = &#63; or returns <code>null</code> if it could not be found, optionally using the finder cache.
    *
    * @param uuid the uuid
    * @param groupId the group ID
    * @param retrieveFromCache whether to use the finder cache
    * @return the matching template, or <code>null</code> if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template fetchByUUID_G(
        java.lang.String uuid, long groupId, boolean retrieveFromCache)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes the template where uuid = &#63; and groupId = &#63; from the database.
    *
    * @param uuid the uuid
    * @param groupId the group ID
    * @return the template that was removed
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template removeByUUID_G(
        java.lang.String uuid, long groupId)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of templates where uuid = &#63; and groupId = &#63;.
    *
    * @param uuid the uuid
    * @param groupId the group ID
    * @return the number of matching templates
    * @throws SystemException if a system exception occurred
    */
    public int countByUUID_G(java.lang.String uuid, long groupId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the templates where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @return the matching templates
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template> findByUuid_C(
        java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the templates where uuid = &#63; and companyId = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param start the lower bound of the range of templates
    * @param end the upper bound of the range of templates (not inclusive)
    * @return the range of matching templates
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template> findByUuid_C(
        java.lang.String uuid, long companyId, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the templates where uuid = &#63; and companyId = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param start the lower bound of the range of templates
    * @param end the upper bound of the range of templates (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching templates
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template> findByUuid_C(
        java.lang.String uuid, long companyId, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first template in the ordered set where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching template
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template findByUuid_C_First(
        java.lang.String uuid, long companyId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first template in the ordered set where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching template, or <code>null</code> if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template fetchByUuid_C_First(
        java.lang.String uuid, long companyId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last template in the ordered set where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching template
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template findByUuid_C_Last(
        java.lang.String uuid, long companyId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last template in the ordered set where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching template, or <code>null</code> if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template fetchByUuid_C_Last(
        java.lang.String uuid, long companyId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the templates before and after the current template in the ordered set where uuid = &#63; and companyId = &#63;.
    *
    * @param templateId the primary key of the current template
    * @param uuid the uuid
    * @param companyId the company ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the previous, current, and next template
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a template with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template[] findByUuid_C_PrevAndNext(
        long templateId, java.lang.String uuid, long companyId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the templates where uuid = &#63; and companyId = &#63; from the database.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @throws SystemException if a system exception occurred
    */
    public void removeByUuid_C(java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of templates where uuid = &#63; and companyId = &#63;.
    *
    * @param uuid the uuid
    * @param companyId the company ID
    * @return the number of matching templates
    * @throws SystemException if a system exception occurred
    */
    public int countByUuid_C(java.lang.String uuid, long companyId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the templates where groupId = &#63;.
    *
    * @param groupId the group ID
    * @return the matching templates
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template> findByGroupId(
        long groupId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the templates where groupId = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param groupId the group ID
    * @param start the lower bound of the range of templates
    * @param end the upper bound of the range of templates (not inclusive)
    * @return the range of matching templates
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template> findByGroupId(
        long groupId, int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the templates where groupId = &#63;.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param groupId the group ID
    * @param start the lower bound of the range of templates
    * @param end the upper bound of the range of templates (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of matching templates
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template> findByGroupId(
        long groupId, int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first template in the ordered set where groupId = &#63;.
    *
    * @param groupId the group ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching template
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template findByGroupId_First(
        long groupId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the first template in the ordered set where groupId = &#63;.
    *
    * @param groupId the group ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the first matching template, or <code>null</code> if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template fetchByGroupId_First(
        long groupId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last template in the ordered set where groupId = &#63;.
    *
    * @param groupId the group ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching template
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template findByGroupId_Last(
        long groupId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the last template in the ordered set where groupId = &#63;.
    *
    * @param groupId the group ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the last matching template, or <code>null</code> if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template fetchByGroupId_Last(
        long groupId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the templates before and after the current template in the ordered set where groupId = &#63;.
    *
    * @param templateId the primary key of the current template
    * @param groupId the group ID
    * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
    * @return the previous, current, and next template
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a template with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template[] findByGroupId_PrevAndNext(
        long templateId, long groupId,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the templates where groupId = &#63; from the database.
    *
    * @param groupId the group ID
    * @throws SystemException if a system exception occurred
    */
    public void removeByGroupId(long groupId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of templates where groupId = &#63;.
    *
    * @param groupId the group ID
    * @return the number of matching templates
    * @throws SystemException if a system exception occurred
    */
    public int countByGroupId(long groupId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the template where groupId = &#63; and nome = &#63; or throws a {@link br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException} if it could not be found.
    *
    * @param groupId the group ID
    * @param nome the nome
    * @return the matching template
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template findByGroupIdNome(
        long groupId, java.lang.String nome)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the template where groupId = &#63; and nome = &#63; or returns <code>null</code> if it could not be found. Uses the finder cache.
    *
    * @param groupId the group ID
    * @param nome the nome
    * @return the matching template, or <code>null</code> if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template fetchByGroupIdNome(
        long groupId, java.lang.String nome)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the template where groupId = &#63; and nome = &#63; or returns <code>null</code> if it could not be found, optionally using the finder cache.
    *
    * @param groupId the group ID
    * @param nome the nome
    * @param retrieveFromCache whether to use the finder cache
    * @return the matching template, or <code>null</code> if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template fetchByGroupIdNome(
        long groupId, java.lang.String nome, boolean retrieveFromCache)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes the template where groupId = &#63; and nome = &#63; from the database.
    *
    * @param groupId the group ID
    * @param nome the nome
    * @return the template that was removed
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template removeByGroupIdNome(
        long groupId, java.lang.String nome)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of templates where groupId = &#63; and nome = &#63;.
    *
    * @param groupId the group ID
    * @param nome the nome
    * @return the number of matching templates
    * @throws SystemException if a system exception occurred
    */
    public int countByGroupIdNome(long groupId, java.lang.String nome)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the template where nome = &#63; and ativo = &#63; or throws a {@link br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException} if it could not be found.
    *
    * @param nome the nome
    * @param ativo the ativo
    * @return the matching template
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template findByNomeAtivo(
        java.lang.String nome, boolean ativo)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the template where nome = &#63; and ativo = &#63; or returns <code>null</code> if it could not be found. Uses the finder cache.
    *
    * @param nome the nome
    * @param ativo the ativo
    * @return the matching template, or <code>null</code> if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template fetchByNomeAtivo(
        java.lang.String nome, boolean ativo)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the template where nome = &#63; and ativo = &#63; or returns <code>null</code> if it could not be found, optionally using the finder cache.
    *
    * @param nome the nome
    * @param ativo the ativo
    * @param retrieveFromCache whether to use the finder cache
    * @return the matching template, or <code>null</code> if a matching template could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template fetchByNomeAtivo(
        java.lang.String nome, boolean ativo, boolean retrieveFromCache)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes the template where nome = &#63; and ativo = &#63; from the database.
    *
    * @param nome the nome
    * @param ativo the ativo
    * @return the template that was removed
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template removeByNomeAtivo(
        java.lang.String nome, boolean ativo)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of templates where nome = &#63; and ativo = &#63;.
    *
    * @param nome the nome
    * @param ativo the ativo
    * @return the number of matching templates
    * @throws SystemException if a system exception occurred
    */
    public int countByNomeAtivo(java.lang.String nome, boolean ativo)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Caches the template in the entity cache if it is enabled.
    *
    * @param template the template
    */
    public void cacheResult(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template template);

    /**
    * Caches the templates in the entity cache if it is enabled.
    *
    * @param templates the templates
    */
    public void cacheResult(
        java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template> templates);

    /**
    * Creates a new template with the primary key. Does not add the template to the database.
    *
    * @param templateId the primary key for the new template
    * @return the new template
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template create(
        long templateId);

    /**
    * Removes the template with the primary key from the database. Also notifies the appropriate model listeners.
    *
    * @param templateId the primary key of the template
    * @return the template that was removed
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a template with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template remove(
        long templateId)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template updateImpl(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template template)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the template with the primary key or throws a {@link br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException} if it could not be found.
    *
    * @param templateId the primary key of the template
    * @return the template
    * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a template with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template findByPrimaryKey(
        long templateId)
        throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException,
            com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the template with the primary key or returns <code>null</code> if it could not be found.
    *
    * @param templateId the primary key of the template
    * @return the template, or <code>null</code> if a template with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template fetchByPrimaryKey(
        long templateId)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns all the templates.
    *
    * @return the templates
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template> findAll()
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns a range of all the templates.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param start the lower bound of the range of templates
    * @param end the upper bound of the range of templates (not inclusive)
    * @return the range of templates
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template> findAll(
        int start, int end)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns an ordered range of all the templates.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param start the lower bound of the range of templates
    * @param end the upper bound of the range of templates (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of templates
    * @throws SystemException if a system exception occurred
    */
    public java.util.List<br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template> findAll(
        int start, int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Removes all the templates from the database.
    *
    * @throws SystemException if a system exception occurred
    */
    public void removeAll()
        throws com.liferay.portal.kernel.exception.SystemException;

    /**
    * Returns the number of templates.
    *
    * @return the number of templates
    * @throws SystemException if a system exception occurred
    */
    public int countAll()
        throws com.liferay.portal.kernel.exception.SystemException;
}
