package br.mp.mprj.portal.portlet.gestaomensagens.service.service.persistence;

import br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException;
import br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template;
import br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateImpl;
import br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl;
import br.mp.mprj.portal.portlet.gestaomensagens.service.service.persistence.TemplatePersistence;

import com.liferay.portal.kernel.cache.CacheRegistryUtil;
import com.liferay.portal.kernel.dao.orm.EntityCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderPath;
import com.liferay.portal.kernel.dao.orm.Query;
import com.liferay.portal.kernel.dao.orm.QueryPos;
import com.liferay.portal.kernel.dao.orm.QueryUtil;
import com.liferay.portal.kernel.dao.orm.Session;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.InstanceFactory;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.PropsKeys;
import com.liferay.portal.kernel.util.PropsUtil;
import com.liferay.portal.kernel.util.SetUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.kernel.util.StringUtil;
import com.liferay.portal.kernel.util.UnmodifiableList;
import com.liferay.portal.kernel.util.Validator;
import com.liferay.portal.kernel.uuid.PortalUUIDUtil;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.ModelListener;
import com.liferay.portal.service.persistence.impl.BasePersistenceImpl;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Set;

/**
 * The persistence implementation for the template service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Henrique Simoes
 * @see TemplatePersistence
 * @see TemplateUtil
 * @generated
 */
public class TemplatePersistenceImpl extends BasePersistenceImpl<Template>
    implements TemplatePersistence {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. Always use {@link TemplateUtil} to access the template persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
     */
    public static final String FINDER_CLASS_NAME_ENTITY = TemplateImpl.class.getName();
    public static final String FINDER_CLASS_NAME_LIST_WITH_PAGINATION = FINDER_CLASS_NAME_ENTITY +
        ".List1";
    public static final String FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION = FINDER_CLASS_NAME_ENTITY +
        ".List2";
    public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_ALL = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, TemplateImpl.class,
            FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findAll", new String[0]);
    public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, TemplateImpl.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findAll", new String[0]);
    public static final FinderPath FINDER_PATH_COUNT_ALL = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, Long.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countAll", new String[0]);
    public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_UUID = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, TemplateImpl.class,
            FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findByUuid",
            new String[] {
                String.class.getName(),
                
            Integer.class.getName(), Integer.class.getName(),
                OrderByComparator.class.getName()
            });
    public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, TemplateImpl.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findByUuid",
            new String[] { String.class.getName() },
            TemplateModelImpl.UUID_COLUMN_BITMASK);
    public static final FinderPath FINDER_PATH_COUNT_BY_UUID = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, Long.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByUuid",
            new String[] { String.class.getName() });
    private static final String _FINDER_COLUMN_UUID_UUID_1 = "template.uuid IS NULL";
    private static final String _FINDER_COLUMN_UUID_UUID_2 = "template.uuid = ?";
    private static final String _FINDER_COLUMN_UUID_UUID_3 = "(template.uuid IS NULL OR template.uuid = '')";
    public static final FinderPath FINDER_PATH_FETCH_BY_UUID_G = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, TemplateImpl.class,
            FINDER_CLASS_NAME_ENTITY, "fetchByUUID_G",
            new String[] { String.class.getName(), Long.class.getName() },
            TemplateModelImpl.UUID_COLUMN_BITMASK |
            TemplateModelImpl.GROUPID_COLUMN_BITMASK);
    public static final FinderPath FINDER_PATH_COUNT_BY_UUID_G = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, Long.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByUUID_G",
            new String[] { String.class.getName(), Long.class.getName() });
    private static final String _FINDER_COLUMN_UUID_G_UUID_1 = "template.uuid IS NULL AND ";
    private static final String _FINDER_COLUMN_UUID_G_UUID_2 = "template.uuid = ? AND ";
    private static final String _FINDER_COLUMN_UUID_G_UUID_3 = "(template.uuid IS NULL OR template.uuid = '') AND ";
    private static final String _FINDER_COLUMN_UUID_G_GROUPID_2 = "template.groupId = ?";
    public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_UUID_C = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, TemplateImpl.class,
            FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findByUuid_C",
            new String[] {
                String.class.getName(), Long.class.getName(),
                
            Integer.class.getName(), Integer.class.getName(),
                OrderByComparator.class.getName()
            });
    public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID_C =
        new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, TemplateImpl.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findByUuid_C",
            new String[] { String.class.getName(), Long.class.getName() },
            TemplateModelImpl.UUID_COLUMN_BITMASK |
            TemplateModelImpl.COMPANYID_COLUMN_BITMASK);
    public static final FinderPath FINDER_PATH_COUNT_BY_UUID_C = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, Long.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByUuid_C",
            new String[] { String.class.getName(), Long.class.getName() });
    private static final String _FINDER_COLUMN_UUID_C_UUID_1 = "template.uuid IS NULL AND ";
    private static final String _FINDER_COLUMN_UUID_C_UUID_2 = "template.uuid = ? AND ";
    private static final String _FINDER_COLUMN_UUID_C_UUID_3 = "(template.uuid IS NULL OR template.uuid = '') AND ";
    private static final String _FINDER_COLUMN_UUID_C_COMPANYID_2 = "template.companyId = ?";
    public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_GROUPID = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, TemplateImpl.class,
            FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findByGroupId",
            new String[] {
                Long.class.getName(),
                
            Integer.class.getName(), Integer.class.getName(),
                OrderByComparator.class.getName()
            });
    public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_GROUPID =
        new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, TemplateImpl.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findByGroupId",
            new String[] { Long.class.getName() },
            TemplateModelImpl.GROUPID_COLUMN_BITMASK);
    public static final FinderPath FINDER_PATH_COUNT_BY_GROUPID = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, Long.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByGroupId",
            new String[] { Long.class.getName() });
    private static final String _FINDER_COLUMN_GROUPID_GROUPID_2 = "template.groupId = ?";
    public static final FinderPath FINDER_PATH_FETCH_BY_GROUPIDNOME = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, TemplateImpl.class,
            FINDER_CLASS_NAME_ENTITY, "fetchByGroupIdNome",
            new String[] { Long.class.getName(), String.class.getName() },
            TemplateModelImpl.GROUPID_COLUMN_BITMASK |
            TemplateModelImpl.NOME_COLUMN_BITMASK);
    public static final FinderPath FINDER_PATH_COUNT_BY_GROUPIDNOME = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, Long.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByGroupIdNome",
            new String[] { Long.class.getName(), String.class.getName() });
    private static final String _FINDER_COLUMN_GROUPIDNOME_GROUPID_2 = "template.groupId = ? AND ";
    private static final String _FINDER_COLUMN_GROUPIDNOME_NOME_1 = "template.nome IS NULL";
    private static final String _FINDER_COLUMN_GROUPIDNOME_NOME_2 = "template.nome = ?";
    private static final String _FINDER_COLUMN_GROUPIDNOME_NOME_3 = "(template.nome IS NULL OR template.nome = '')";
    public static final FinderPath FINDER_PATH_FETCH_BY_NOMEATIVO = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, TemplateImpl.class,
            FINDER_CLASS_NAME_ENTITY, "fetchByNomeAtivo",
            new String[] { String.class.getName(), Boolean.class.getName() },
            TemplateModelImpl.NOME_COLUMN_BITMASK |
            TemplateModelImpl.ATIVO_COLUMN_BITMASK);
    public static final FinderPath FINDER_PATH_COUNT_BY_NOMEATIVO = new FinderPath(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateModelImpl.FINDER_CACHE_ENABLED, Long.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByNomeAtivo",
            new String[] { String.class.getName(), Boolean.class.getName() });
    private static final String _FINDER_COLUMN_NOMEATIVO_NOME_1 = "template.nome IS NULL AND ";
    private static final String _FINDER_COLUMN_NOMEATIVO_NOME_2 = "template.nome = ? AND ";
    private static final String _FINDER_COLUMN_NOMEATIVO_NOME_3 = "(template.nome IS NULL OR template.nome = '') AND ";
    private static final String _FINDER_COLUMN_NOMEATIVO_ATIVO_2 = "template.ativo = ?";
    private static final String _SQL_SELECT_TEMPLATE = "SELECT template FROM Template template";
    private static final String _SQL_SELECT_TEMPLATE_WHERE = "SELECT template FROM Template template WHERE ";
    private static final String _SQL_COUNT_TEMPLATE = "SELECT COUNT(template) FROM Template template";
    private static final String _SQL_COUNT_TEMPLATE_WHERE = "SELECT COUNT(template) FROM Template template WHERE ";
    private static final String _ORDER_BY_ENTITY_ALIAS = "template.";
    private static final String _NO_SUCH_ENTITY_WITH_PRIMARY_KEY = "No Template exists with the primary key ";
    private static final String _NO_SUCH_ENTITY_WITH_KEY = "No Template exists with the key {";
    private static final boolean _HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE = GetterUtil.getBoolean(PropsUtil.get(
                PropsKeys.HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE));
    private static Log _log = LogFactoryUtil.getLog(TemplatePersistenceImpl.class);
    private static Set<String> _badColumnNames = SetUtil.fromArray(new String[] {
                "uuid"
            });
    private static Template _nullTemplate = new TemplateImpl() {
            @Override
            public Object clone() {
                return this;
            }

            @Override
            public CacheModel<Template> toCacheModel() {
                return _nullTemplateCacheModel;
            }
        };

    private static CacheModel<Template> _nullTemplateCacheModel = new CacheModel<Template>() {
            @Override
            public Template toEntityModel() {
                return _nullTemplate;
            }
        };

    public TemplatePersistenceImpl() {
        setModelClass(Template.class);
    }

    /**
     * Returns all the templates where uuid = &#63;.
     *
     * @param uuid the uuid
     * @return the matching templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Template> findByUuid(String uuid) throws SystemException {
        return findByUuid(uuid, QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
    }

    /**
     * Returns a range of all the templates where uuid = &#63;.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param uuid the uuid
     * @param start the lower bound of the range of templates
     * @param end the upper bound of the range of templates (not inclusive)
     * @return the range of matching templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Template> findByUuid(String uuid, int start, int end)
        throws SystemException {
        return findByUuid(uuid, start, end, null);
    }

    /**
     * Returns an ordered range of all the templates where uuid = &#63;.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param uuid the uuid
     * @param start the lower bound of the range of templates
     * @param end the upper bound of the range of templates (not inclusive)
     * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
     * @return the ordered range of matching templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Template> findByUuid(String uuid, int start, int end,
        OrderByComparator orderByComparator) throws SystemException {
        boolean pagination = true;
        FinderPath finderPath = null;
        Object[] finderArgs = null;

        if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
                (orderByComparator == null)) {
            pagination = false;
            finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID;
            finderArgs = new Object[] { uuid };
        } else {
            finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_UUID;
            finderArgs = new Object[] { uuid, start, end, orderByComparator };
        }

        List<Template> list = (List<Template>) FinderCacheUtil.getResult(finderPath,
                finderArgs, this);

        if ((list != null) && !list.isEmpty()) {
            for (Template template : list) {
                if (!Validator.equals(uuid, template.getUuid())) {
                    list = null;

                    break;
                }
            }
        }

        if (list == null) {
            StringBundler query = null;

            if (orderByComparator != null) {
                query = new StringBundler(3 +
                        (orderByComparator.getOrderByFields().length * 3));
            } else {
                query = new StringBundler(3);
            }

            query.append(_SQL_SELECT_TEMPLATE_WHERE);

            boolean bindUuid = false;

            if (uuid == null) {
                query.append(_FINDER_COLUMN_UUID_UUID_1);
            } else if (uuid.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_UUID_UUID_3);
            } else {
                bindUuid = true;

                query.append(_FINDER_COLUMN_UUID_UUID_2);
            }

            if (orderByComparator != null) {
                appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
                    orderByComparator);
            } else
             if (pagination) {
                query.append(TemplateModelImpl.ORDER_BY_JPQL);
            }

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                if (bindUuid) {
                    qPos.add(uuid);
                }

                if (!pagination) {
                    list = (List<Template>) QueryUtil.list(q, getDialect(),
                            start, end, false);

                    Collections.sort(list);

                    list = new UnmodifiableList<Template>(list);
                } else {
                    list = (List<Template>) QueryUtil.list(q, getDialect(),
                            start, end);
                }

                cacheResult(list);

                FinderCacheUtil.putResult(finderPath, finderArgs, list);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return list;
    }

    /**
     * Returns the first template in the ordered set where uuid = &#63;.
     *
     * @param uuid the uuid
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the first matching template
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template findByUuid_First(String uuid,
        OrderByComparator orderByComparator)
        throws NoSuchTemplateException, SystemException {
        Template template = fetchByUuid_First(uuid, orderByComparator);

        if (template != null) {
            return template;
        }

        StringBundler msg = new StringBundler(4);

        msg.append(_NO_SUCH_ENTITY_WITH_KEY);

        msg.append("uuid=");
        msg.append(uuid);

        msg.append(StringPool.CLOSE_CURLY_BRACE);

        throw new NoSuchTemplateException(msg.toString());
    }

    /**
     * Returns the first template in the ordered set where uuid = &#63;.
     *
     * @param uuid the uuid
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the first matching template, or <code>null</code> if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template fetchByUuid_First(String uuid,
        OrderByComparator orderByComparator) throws SystemException {
        List<Template> list = findByUuid(uuid, 0, 1, orderByComparator);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    /**
     * Returns the last template in the ordered set where uuid = &#63;.
     *
     * @param uuid the uuid
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the last matching template
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template findByUuid_Last(String uuid,
        OrderByComparator orderByComparator)
        throws NoSuchTemplateException, SystemException {
        Template template = fetchByUuid_Last(uuid, orderByComparator);

        if (template != null) {
            return template;
        }

        StringBundler msg = new StringBundler(4);

        msg.append(_NO_SUCH_ENTITY_WITH_KEY);

        msg.append("uuid=");
        msg.append(uuid);

        msg.append(StringPool.CLOSE_CURLY_BRACE);

        throw new NoSuchTemplateException(msg.toString());
    }

    /**
     * Returns the last template in the ordered set where uuid = &#63;.
     *
     * @param uuid the uuid
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the last matching template, or <code>null</code> if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template fetchByUuid_Last(String uuid,
        OrderByComparator orderByComparator) throws SystemException {
        int count = countByUuid(uuid);

        if (count == 0) {
            return null;
        }

        List<Template> list = findByUuid(uuid, count - 1, count,
                orderByComparator);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    /**
     * Returns the templates before and after the current template in the ordered set where uuid = &#63;.
     *
     * @param templateId the primary key of the current template
     * @param uuid the uuid
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the previous, current, and next template
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a template with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template[] findByUuid_PrevAndNext(long templateId, String uuid,
        OrderByComparator orderByComparator)
        throws NoSuchTemplateException, SystemException {
        Template template = findByPrimaryKey(templateId);

        Session session = null;

        try {
            session = openSession();

            Template[] array = new TemplateImpl[3];

            array[0] = getByUuid_PrevAndNext(session, template, uuid,
                    orderByComparator, true);

            array[1] = template;

            array[2] = getByUuid_PrevAndNext(session, template, uuid,
                    orderByComparator, false);

            return array;
        } catch (Exception e) {
            throw processException(e);
        } finally {
            closeSession(session);
        }
    }

    protected Template getByUuid_PrevAndNext(Session session,
        Template template, String uuid, OrderByComparator orderByComparator,
        boolean previous) {
        StringBundler query = null;

        if (orderByComparator != null) {
            query = new StringBundler(6 +
                    (orderByComparator.getOrderByFields().length * 6));
        } else {
            query = new StringBundler(3);
        }

        query.append(_SQL_SELECT_TEMPLATE_WHERE);

        boolean bindUuid = false;

        if (uuid == null) {
            query.append(_FINDER_COLUMN_UUID_UUID_1);
        } else if (uuid.equals(StringPool.BLANK)) {
            query.append(_FINDER_COLUMN_UUID_UUID_3);
        } else {
            bindUuid = true;

            query.append(_FINDER_COLUMN_UUID_UUID_2);
        }

        if (orderByComparator != null) {
            String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

            if (orderByConditionFields.length > 0) {
                query.append(WHERE_AND);
            }

            for (int i = 0; i < orderByConditionFields.length; i++) {
                query.append(_ORDER_BY_ENTITY_ALIAS);
                query.append(orderByConditionFields[i]);

                if ((i + 1) < orderByConditionFields.length) {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(WHERE_GREATER_THAN_HAS_NEXT);
                    } else {
                        query.append(WHERE_LESSER_THAN_HAS_NEXT);
                    }
                } else {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(WHERE_GREATER_THAN);
                    } else {
                        query.append(WHERE_LESSER_THAN);
                    }
                }
            }

            query.append(ORDER_BY_CLAUSE);

            String[] orderByFields = orderByComparator.getOrderByFields();

            for (int i = 0; i < orderByFields.length; i++) {
                query.append(_ORDER_BY_ENTITY_ALIAS);
                query.append(orderByFields[i]);

                if ((i + 1) < orderByFields.length) {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(ORDER_BY_ASC_HAS_NEXT);
                    } else {
                        query.append(ORDER_BY_DESC_HAS_NEXT);
                    }
                } else {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(ORDER_BY_ASC);
                    } else {
                        query.append(ORDER_BY_DESC);
                    }
                }
            }
        } else {
            query.append(TemplateModelImpl.ORDER_BY_JPQL);
        }

        String sql = query.toString();

        Query q = session.createQuery(sql);

        q.setFirstResult(0);
        q.setMaxResults(2);

        QueryPos qPos = QueryPos.getInstance(q);

        if (bindUuid) {
            qPos.add(uuid);
        }

        if (orderByComparator != null) {
            Object[] values = orderByComparator.getOrderByConditionValues(template);

            for (Object value : values) {
                qPos.add(value);
            }
        }

        List<Template> list = q.list();

        if (list.size() == 2) {
            return list.get(1);
        } else {
            return null;
        }
    }

    /**
     * Removes all the templates where uuid = &#63; from the database.
     *
     * @param uuid the uuid
     * @throws SystemException if a system exception occurred
     */
    @Override
    public void removeByUuid(String uuid) throws SystemException {
        for (Template template : findByUuid(uuid, QueryUtil.ALL_POS,
                QueryUtil.ALL_POS, null)) {
            remove(template);
        }
    }

    /**
     * Returns the number of templates where uuid = &#63;.
     *
     * @param uuid the uuid
     * @return the number of matching templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public int countByUuid(String uuid) throws SystemException {
        FinderPath finderPath = FINDER_PATH_COUNT_BY_UUID;

        Object[] finderArgs = new Object[] { uuid };

        Long count = (Long) FinderCacheUtil.getResult(finderPath, finderArgs,
                this);

        if (count == null) {
            StringBundler query = new StringBundler(2);

            query.append(_SQL_COUNT_TEMPLATE_WHERE);

            boolean bindUuid = false;

            if (uuid == null) {
                query.append(_FINDER_COLUMN_UUID_UUID_1);
            } else if (uuid.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_UUID_UUID_3);
            } else {
                bindUuid = true;

                query.append(_FINDER_COLUMN_UUID_UUID_2);
            }

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                if (bindUuid) {
                    qPos.add(uuid);
                }

                count = (Long) q.uniqueResult();

                FinderCacheUtil.putResult(finderPath, finderArgs, count);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return count.intValue();
    }

    /**
     * Returns the template where uuid = &#63; and groupId = &#63; or throws a {@link br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException} if it could not be found.
     *
     * @param uuid the uuid
     * @param groupId the group ID
     * @return the matching template
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template findByUUID_G(String uuid, long groupId)
        throws NoSuchTemplateException, SystemException {
        Template template = fetchByUUID_G(uuid, groupId);

        if (template == null) {
            StringBundler msg = new StringBundler(6);

            msg.append(_NO_SUCH_ENTITY_WITH_KEY);

            msg.append("uuid=");
            msg.append(uuid);

            msg.append(", groupId=");
            msg.append(groupId);

            msg.append(StringPool.CLOSE_CURLY_BRACE);

            if (_log.isWarnEnabled()) {
                _log.warn(msg.toString());
            }

            throw new NoSuchTemplateException(msg.toString());
        }

        return template;
    }

    /**
     * Returns the template where uuid = &#63; and groupId = &#63; or returns <code>null</code> if it could not be found. Uses the finder cache.
     *
     * @param uuid the uuid
     * @param groupId the group ID
     * @return the matching template, or <code>null</code> if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template fetchByUUID_G(String uuid, long groupId)
        throws SystemException {
        return fetchByUUID_G(uuid, groupId, true);
    }

    /**
     * Returns the template where uuid = &#63; and groupId = &#63; or returns <code>null</code> if it could not be found, optionally using the finder cache.
     *
     * @param uuid the uuid
     * @param groupId the group ID
     * @param retrieveFromCache whether to use the finder cache
     * @return the matching template, or <code>null</code> if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template fetchByUUID_G(String uuid, long groupId,
        boolean retrieveFromCache) throws SystemException {
        Object[] finderArgs = new Object[] { uuid, groupId };

        Object result = null;

        if (retrieveFromCache) {
            result = FinderCacheUtil.getResult(FINDER_PATH_FETCH_BY_UUID_G,
                    finderArgs, this);
        }

        if (result instanceof Template) {
            Template template = (Template) result;

            if (!Validator.equals(uuid, template.getUuid()) ||
                    (groupId != template.getGroupId())) {
                result = null;
            }
        }

        if (result == null) {
            StringBundler query = new StringBundler(4);

            query.append(_SQL_SELECT_TEMPLATE_WHERE);

            boolean bindUuid = false;

            if (uuid == null) {
                query.append(_FINDER_COLUMN_UUID_G_UUID_1);
            } else if (uuid.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_UUID_G_UUID_3);
            } else {
                bindUuid = true;

                query.append(_FINDER_COLUMN_UUID_G_UUID_2);
            }

            query.append(_FINDER_COLUMN_UUID_G_GROUPID_2);

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                if (bindUuid) {
                    qPos.add(uuid);
                }

                qPos.add(groupId);

                List<Template> list = q.list();

                if (list.isEmpty()) {
                    FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_UUID_G,
                        finderArgs, list);
                } else {
                    Template template = list.get(0);

                    result = template;

                    cacheResult(template);

                    if ((template.getUuid() == null) ||
                            !template.getUuid().equals(uuid) ||
                            (template.getGroupId() != groupId)) {
                        FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_UUID_G,
                            finderArgs, template);
                    }
                }
            } catch (Exception e) {
                FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_UUID_G,
                    finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        if (result instanceof List<?>) {
            return null;
        } else {
            return (Template) result;
        }
    }

    /**
     * Removes the template where uuid = &#63; and groupId = &#63; from the database.
     *
     * @param uuid the uuid
     * @param groupId the group ID
     * @return the template that was removed
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template removeByUUID_G(String uuid, long groupId)
        throws NoSuchTemplateException, SystemException {
        Template template = findByUUID_G(uuid, groupId);

        return remove(template);
    }

    /**
     * Returns the number of templates where uuid = &#63; and groupId = &#63;.
     *
     * @param uuid the uuid
     * @param groupId the group ID
     * @return the number of matching templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public int countByUUID_G(String uuid, long groupId)
        throws SystemException {
        FinderPath finderPath = FINDER_PATH_COUNT_BY_UUID_G;

        Object[] finderArgs = new Object[] { uuid, groupId };

        Long count = (Long) FinderCacheUtil.getResult(finderPath, finderArgs,
                this);

        if (count == null) {
            StringBundler query = new StringBundler(3);

            query.append(_SQL_COUNT_TEMPLATE_WHERE);

            boolean bindUuid = false;

            if (uuid == null) {
                query.append(_FINDER_COLUMN_UUID_G_UUID_1);
            } else if (uuid.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_UUID_G_UUID_3);
            } else {
                bindUuid = true;

                query.append(_FINDER_COLUMN_UUID_G_UUID_2);
            }

            query.append(_FINDER_COLUMN_UUID_G_GROUPID_2);

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                if (bindUuid) {
                    qPos.add(uuid);
                }

                qPos.add(groupId);

                count = (Long) q.uniqueResult();

                FinderCacheUtil.putResult(finderPath, finderArgs, count);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return count.intValue();
    }

    /**
     * Returns all the templates where uuid = &#63; and companyId = &#63;.
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @return the matching templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Template> findByUuid_C(String uuid, long companyId)
        throws SystemException {
        return findByUuid_C(uuid, companyId, QueryUtil.ALL_POS,
            QueryUtil.ALL_POS, null);
    }

    /**
     * Returns a range of all the templates where uuid = &#63; and companyId = &#63;.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @param start the lower bound of the range of templates
     * @param end the upper bound of the range of templates (not inclusive)
     * @return the range of matching templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Template> findByUuid_C(String uuid, long companyId, int start,
        int end) throws SystemException {
        return findByUuid_C(uuid, companyId, start, end, null);
    }

    /**
     * Returns an ordered range of all the templates where uuid = &#63; and companyId = &#63;.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @param start the lower bound of the range of templates
     * @param end the upper bound of the range of templates (not inclusive)
     * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
     * @return the ordered range of matching templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Template> findByUuid_C(String uuid, long companyId, int start,
        int end, OrderByComparator orderByComparator) throws SystemException {
        boolean pagination = true;
        FinderPath finderPath = null;
        Object[] finderArgs = null;

        if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
                (orderByComparator == null)) {
            pagination = false;
            finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID_C;
            finderArgs = new Object[] { uuid, companyId };
        } else {
            finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_UUID_C;
            finderArgs = new Object[] {
                    uuid, companyId,
                    
                    start, end, orderByComparator
                };
        }

        List<Template> list = (List<Template>) FinderCacheUtil.getResult(finderPath,
                finderArgs, this);

        if ((list != null) && !list.isEmpty()) {
            for (Template template : list) {
                if (!Validator.equals(uuid, template.getUuid()) ||
                        (companyId != template.getCompanyId())) {
                    list = null;

                    break;
                }
            }
        }

        if (list == null) {
            StringBundler query = null;

            if (orderByComparator != null) {
                query = new StringBundler(4 +
                        (orderByComparator.getOrderByFields().length * 3));
            } else {
                query = new StringBundler(4);
            }

            query.append(_SQL_SELECT_TEMPLATE_WHERE);

            boolean bindUuid = false;

            if (uuid == null) {
                query.append(_FINDER_COLUMN_UUID_C_UUID_1);
            } else if (uuid.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_UUID_C_UUID_3);
            } else {
                bindUuid = true;

                query.append(_FINDER_COLUMN_UUID_C_UUID_2);
            }

            query.append(_FINDER_COLUMN_UUID_C_COMPANYID_2);

            if (orderByComparator != null) {
                appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
                    orderByComparator);
            } else
             if (pagination) {
                query.append(TemplateModelImpl.ORDER_BY_JPQL);
            }

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                if (bindUuid) {
                    qPos.add(uuid);
                }

                qPos.add(companyId);

                if (!pagination) {
                    list = (List<Template>) QueryUtil.list(q, getDialect(),
                            start, end, false);

                    Collections.sort(list);

                    list = new UnmodifiableList<Template>(list);
                } else {
                    list = (List<Template>) QueryUtil.list(q, getDialect(),
                            start, end);
                }

                cacheResult(list);

                FinderCacheUtil.putResult(finderPath, finderArgs, list);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return list;
    }

    /**
     * Returns the first template in the ordered set where uuid = &#63; and companyId = &#63;.
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the first matching template
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template findByUuid_C_First(String uuid, long companyId,
        OrderByComparator orderByComparator)
        throws NoSuchTemplateException, SystemException {
        Template template = fetchByUuid_C_First(uuid, companyId,
                orderByComparator);

        if (template != null) {
            return template;
        }

        StringBundler msg = new StringBundler(6);

        msg.append(_NO_SUCH_ENTITY_WITH_KEY);

        msg.append("uuid=");
        msg.append(uuid);

        msg.append(", companyId=");
        msg.append(companyId);

        msg.append(StringPool.CLOSE_CURLY_BRACE);

        throw new NoSuchTemplateException(msg.toString());
    }

    /**
     * Returns the first template in the ordered set where uuid = &#63; and companyId = &#63;.
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the first matching template, or <code>null</code> if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template fetchByUuid_C_First(String uuid, long companyId,
        OrderByComparator orderByComparator) throws SystemException {
        List<Template> list = findByUuid_C(uuid, companyId, 0, 1,
                orderByComparator);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    /**
     * Returns the last template in the ordered set where uuid = &#63; and companyId = &#63;.
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the last matching template
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template findByUuid_C_Last(String uuid, long companyId,
        OrderByComparator orderByComparator)
        throws NoSuchTemplateException, SystemException {
        Template template = fetchByUuid_C_Last(uuid, companyId,
                orderByComparator);

        if (template != null) {
            return template;
        }

        StringBundler msg = new StringBundler(6);

        msg.append(_NO_SUCH_ENTITY_WITH_KEY);

        msg.append("uuid=");
        msg.append(uuid);

        msg.append(", companyId=");
        msg.append(companyId);

        msg.append(StringPool.CLOSE_CURLY_BRACE);

        throw new NoSuchTemplateException(msg.toString());
    }

    /**
     * Returns the last template in the ordered set where uuid = &#63; and companyId = &#63;.
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the last matching template, or <code>null</code> if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template fetchByUuid_C_Last(String uuid, long companyId,
        OrderByComparator orderByComparator) throws SystemException {
        int count = countByUuid_C(uuid, companyId);

        if (count == 0) {
            return null;
        }

        List<Template> list = findByUuid_C(uuid, companyId, count - 1, count,
                orderByComparator);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    /**
     * Returns the templates before and after the current template in the ordered set where uuid = &#63; and companyId = &#63;.
     *
     * @param templateId the primary key of the current template
     * @param uuid the uuid
     * @param companyId the company ID
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the previous, current, and next template
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a template with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template[] findByUuid_C_PrevAndNext(long templateId, String uuid,
        long companyId, OrderByComparator orderByComparator)
        throws NoSuchTemplateException, SystemException {
        Template template = findByPrimaryKey(templateId);

        Session session = null;

        try {
            session = openSession();

            Template[] array = new TemplateImpl[3];

            array[0] = getByUuid_C_PrevAndNext(session, template, uuid,
                    companyId, orderByComparator, true);

            array[1] = template;

            array[2] = getByUuid_C_PrevAndNext(session, template, uuid,
                    companyId, orderByComparator, false);

            return array;
        } catch (Exception e) {
            throw processException(e);
        } finally {
            closeSession(session);
        }
    }

    protected Template getByUuid_C_PrevAndNext(Session session,
        Template template, String uuid, long companyId,
        OrderByComparator orderByComparator, boolean previous) {
        StringBundler query = null;

        if (orderByComparator != null) {
            query = new StringBundler(6 +
                    (orderByComparator.getOrderByFields().length * 6));
        } else {
            query = new StringBundler(3);
        }

        query.append(_SQL_SELECT_TEMPLATE_WHERE);

        boolean bindUuid = false;

        if (uuid == null) {
            query.append(_FINDER_COLUMN_UUID_C_UUID_1);
        } else if (uuid.equals(StringPool.BLANK)) {
            query.append(_FINDER_COLUMN_UUID_C_UUID_3);
        } else {
            bindUuid = true;

            query.append(_FINDER_COLUMN_UUID_C_UUID_2);
        }

        query.append(_FINDER_COLUMN_UUID_C_COMPANYID_2);

        if (orderByComparator != null) {
            String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

            if (orderByConditionFields.length > 0) {
                query.append(WHERE_AND);
            }

            for (int i = 0; i < orderByConditionFields.length; i++) {
                query.append(_ORDER_BY_ENTITY_ALIAS);
                query.append(orderByConditionFields[i]);

                if ((i + 1) < orderByConditionFields.length) {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(WHERE_GREATER_THAN_HAS_NEXT);
                    } else {
                        query.append(WHERE_LESSER_THAN_HAS_NEXT);
                    }
                } else {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(WHERE_GREATER_THAN);
                    } else {
                        query.append(WHERE_LESSER_THAN);
                    }
                }
            }

            query.append(ORDER_BY_CLAUSE);

            String[] orderByFields = orderByComparator.getOrderByFields();

            for (int i = 0; i < orderByFields.length; i++) {
                query.append(_ORDER_BY_ENTITY_ALIAS);
                query.append(orderByFields[i]);

                if ((i + 1) < orderByFields.length) {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(ORDER_BY_ASC_HAS_NEXT);
                    } else {
                        query.append(ORDER_BY_DESC_HAS_NEXT);
                    }
                } else {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(ORDER_BY_ASC);
                    } else {
                        query.append(ORDER_BY_DESC);
                    }
                }
            }
        } else {
            query.append(TemplateModelImpl.ORDER_BY_JPQL);
        }

        String sql = query.toString();

        Query q = session.createQuery(sql);

        q.setFirstResult(0);
        q.setMaxResults(2);

        QueryPos qPos = QueryPos.getInstance(q);

        if (bindUuid) {
            qPos.add(uuid);
        }

        qPos.add(companyId);

        if (orderByComparator != null) {
            Object[] values = orderByComparator.getOrderByConditionValues(template);

            for (Object value : values) {
                qPos.add(value);
            }
        }

        List<Template> list = q.list();

        if (list.size() == 2) {
            return list.get(1);
        } else {
            return null;
        }
    }

    /**
     * Removes all the templates where uuid = &#63; and companyId = &#63; from the database.
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @throws SystemException if a system exception occurred
     */
    @Override
    public void removeByUuid_C(String uuid, long companyId)
        throws SystemException {
        for (Template template : findByUuid_C(uuid, companyId,
                QueryUtil.ALL_POS, QueryUtil.ALL_POS, null)) {
            remove(template);
        }
    }

    /**
     * Returns the number of templates where uuid = &#63; and companyId = &#63;.
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @return the number of matching templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public int countByUuid_C(String uuid, long companyId)
        throws SystemException {
        FinderPath finderPath = FINDER_PATH_COUNT_BY_UUID_C;

        Object[] finderArgs = new Object[] { uuid, companyId };

        Long count = (Long) FinderCacheUtil.getResult(finderPath, finderArgs,
                this);

        if (count == null) {
            StringBundler query = new StringBundler(3);

            query.append(_SQL_COUNT_TEMPLATE_WHERE);

            boolean bindUuid = false;

            if (uuid == null) {
                query.append(_FINDER_COLUMN_UUID_C_UUID_1);
            } else if (uuid.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_UUID_C_UUID_3);
            } else {
                bindUuid = true;

                query.append(_FINDER_COLUMN_UUID_C_UUID_2);
            }

            query.append(_FINDER_COLUMN_UUID_C_COMPANYID_2);

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                if (bindUuid) {
                    qPos.add(uuid);
                }

                qPos.add(companyId);

                count = (Long) q.uniqueResult();

                FinderCacheUtil.putResult(finderPath, finderArgs, count);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return count.intValue();
    }

    /**
     * Returns all the templates where groupId = &#63;.
     *
     * @param groupId the group ID
     * @return the matching templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Template> findByGroupId(long groupId) throws SystemException {
        return findByGroupId(groupId, QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
    }

    /**
     * Returns a range of all the templates where groupId = &#63;.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param groupId the group ID
     * @param start the lower bound of the range of templates
     * @param end the upper bound of the range of templates (not inclusive)
     * @return the range of matching templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Template> findByGroupId(long groupId, int start, int end)
        throws SystemException {
        return findByGroupId(groupId, start, end, null);
    }

    /**
     * Returns an ordered range of all the templates where groupId = &#63;.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param groupId the group ID
     * @param start the lower bound of the range of templates
     * @param end the upper bound of the range of templates (not inclusive)
     * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
     * @return the ordered range of matching templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Template> findByGroupId(long groupId, int start, int end,
        OrderByComparator orderByComparator) throws SystemException {
        boolean pagination = true;
        FinderPath finderPath = null;
        Object[] finderArgs = null;

        if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
                (orderByComparator == null)) {
            pagination = false;
            finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_GROUPID;
            finderArgs = new Object[] { groupId };
        } else {
            finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_GROUPID;
            finderArgs = new Object[] { groupId, start, end, orderByComparator };
        }

        List<Template> list = (List<Template>) FinderCacheUtil.getResult(finderPath,
                finderArgs, this);

        if ((list != null) && !list.isEmpty()) {
            for (Template template : list) {
                if ((groupId != template.getGroupId())) {
                    list = null;

                    break;
                }
            }
        }

        if (list == null) {
            StringBundler query = null;

            if (orderByComparator != null) {
                query = new StringBundler(3 +
                        (orderByComparator.getOrderByFields().length * 3));
            } else {
                query = new StringBundler(3);
            }

            query.append(_SQL_SELECT_TEMPLATE_WHERE);

            query.append(_FINDER_COLUMN_GROUPID_GROUPID_2);

            if (orderByComparator != null) {
                appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
                    orderByComparator);
            } else
             if (pagination) {
                query.append(TemplateModelImpl.ORDER_BY_JPQL);
            }

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                qPos.add(groupId);

                if (!pagination) {
                    list = (List<Template>) QueryUtil.list(q, getDialect(),
                            start, end, false);

                    Collections.sort(list);

                    list = new UnmodifiableList<Template>(list);
                } else {
                    list = (List<Template>) QueryUtil.list(q, getDialect(),
                            start, end);
                }

                cacheResult(list);

                FinderCacheUtil.putResult(finderPath, finderArgs, list);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return list;
    }

    /**
     * Returns the first template in the ordered set where groupId = &#63;.
     *
     * @param groupId the group ID
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the first matching template
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template findByGroupId_First(long groupId,
        OrderByComparator orderByComparator)
        throws NoSuchTemplateException, SystemException {
        Template template = fetchByGroupId_First(groupId, orderByComparator);

        if (template != null) {
            return template;
        }

        StringBundler msg = new StringBundler(4);

        msg.append(_NO_SUCH_ENTITY_WITH_KEY);

        msg.append("groupId=");
        msg.append(groupId);

        msg.append(StringPool.CLOSE_CURLY_BRACE);

        throw new NoSuchTemplateException(msg.toString());
    }

    /**
     * Returns the first template in the ordered set where groupId = &#63;.
     *
     * @param groupId the group ID
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the first matching template, or <code>null</code> if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template fetchByGroupId_First(long groupId,
        OrderByComparator orderByComparator) throws SystemException {
        List<Template> list = findByGroupId(groupId, 0, 1, orderByComparator);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    /**
     * Returns the last template in the ordered set where groupId = &#63;.
     *
     * @param groupId the group ID
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the last matching template
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template findByGroupId_Last(long groupId,
        OrderByComparator orderByComparator)
        throws NoSuchTemplateException, SystemException {
        Template template = fetchByGroupId_Last(groupId, orderByComparator);

        if (template != null) {
            return template;
        }

        StringBundler msg = new StringBundler(4);

        msg.append(_NO_SUCH_ENTITY_WITH_KEY);

        msg.append("groupId=");
        msg.append(groupId);

        msg.append(StringPool.CLOSE_CURLY_BRACE);

        throw new NoSuchTemplateException(msg.toString());
    }

    /**
     * Returns the last template in the ordered set where groupId = &#63;.
     *
     * @param groupId the group ID
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the last matching template, or <code>null</code> if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template fetchByGroupId_Last(long groupId,
        OrderByComparator orderByComparator) throws SystemException {
        int count = countByGroupId(groupId);

        if (count == 0) {
            return null;
        }

        List<Template> list = findByGroupId(groupId, count - 1, count,
                orderByComparator);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    /**
     * Returns the templates before and after the current template in the ordered set where groupId = &#63;.
     *
     * @param templateId the primary key of the current template
     * @param groupId the group ID
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the previous, current, and next template
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a template with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template[] findByGroupId_PrevAndNext(long templateId, long groupId,
        OrderByComparator orderByComparator)
        throws NoSuchTemplateException, SystemException {
        Template template = findByPrimaryKey(templateId);

        Session session = null;

        try {
            session = openSession();

            Template[] array = new TemplateImpl[3];

            array[0] = getByGroupId_PrevAndNext(session, template, groupId,
                    orderByComparator, true);

            array[1] = template;

            array[2] = getByGroupId_PrevAndNext(session, template, groupId,
                    orderByComparator, false);

            return array;
        } catch (Exception e) {
            throw processException(e);
        } finally {
            closeSession(session);
        }
    }

    protected Template getByGroupId_PrevAndNext(Session session,
        Template template, long groupId, OrderByComparator orderByComparator,
        boolean previous) {
        StringBundler query = null;

        if (orderByComparator != null) {
            query = new StringBundler(6 +
                    (orderByComparator.getOrderByFields().length * 6));
        } else {
            query = new StringBundler(3);
        }

        query.append(_SQL_SELECT_TEMPLATE_WHERE);

        query.append(_FINDER_COLUMN_GROUPID_GROUPID_2);

        if (orderByComparator != null) {
            String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

            if (orderByConditionFields.length > 0) {
                query.append(WHERE_AND);
            }

            for (int i = 0; i < orderByConditionFields.length; i++) {
                query.append(_ORDER_BY_ENTITY_ALIAS);
                query.append(orderByConditionFields[i]);

                if ((i + 1) < orderByConditionFields.length) {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(WHERE_GREATER_THAN_HAS_NEXT);
                    } else {
                        query.append(WHERE_LESSER_THAN_HAS_NEXT);
                    }
                } else {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(WHERE_GREATER_THAN);
                    } else {
                        query.append(WHERE_LESSER_THAN);
                    }
                }
            }

            query.append(ORDER_BY_CLAUSE);

            String[] orderByFields = orderByComparator.getOrderByFields();

            for (int i = 0; i < orderByFields.length; i++) {
                query.append(_ORDER_BY_ENTITY_ALIAS);
                query.append(orderByFields[i]);

                if ((i + 1) < orderByFields.length) {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(ORDER_BY_ASC_HAS_NEXT);
                    } else {
                        query.append(ORDER_BY_DESC_HAS_NEXT);
                    }
                } else {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(ORDER_BY_ASC);
                    } else {
                        query.append(ORDER_BY_DESC);
                    }
                }
            }
        } else {
            query.append(TemplateModelImpl.ORDER_BY_JPQL);
        }

        String sql = query.toString();

        Query q = session.createQuery(sql);

        q.setFirstResult(0);
        q.setMaxResults(2);

        QueryPos qPos = QueryPos.getInstance(q);

        qPos.add(groupId);

        if (orderByComparator != null) {
            Object[] values = orderByComparator.getOrderByConditionValues(template);

            for (Object value : values) {
                qPos.add(value);
            }
        }

        List<Template> list = q.list();

        if (list.size() == 2) {
            return list.get(1);
        } else {
            return null;
        }
    }

    /**
     * Removes all the templates where groupId = &#63; from the database.
     *
     * @param groupId the group ID
     * @throws SystemException if a system exception occurred
     */
    @Override
    public void removeByGroupId(long groupId) throws SystemException {
        for (Template template : findByGroupId(groupId, QueryUtil.ALL_POS,
                QueryUtil.ALL_POS, null)) {
            remove(template);
        }
    }

    /**
     * Returns the number of templates where groupId = &#63;.
     *
     * @param groupId the group ID
     * @return the number of matching templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public int countByGroupId(long groupId) throws SystemException {
        FinderPath finderPath = FINDER_PATH_COUNT_BY_GROUPID;

        Object[] finderArgs = new Object[] { groupId };

        Long count = (Long) FinderCacheUtil.getResult(finderPath, finderArgs,
                this);

        if (count == null) {
            StringBundler query = new StringBundler(2);

            query.append(_SQL_COUNT_TEMPLATE_WHERE);

            query.append(_FINDER_COLUMN_GROUPID_GROUPID_2);

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                qPos.add(groupId);

                count = (Long) q.uniqueResult();

                FinderCacheUtil.putResult(finderPath, finderArgs, count);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return count.intValue();
    }

    /**
     * Returns the template where groupId = &#63; and nome = &#63; or throws a {@link br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException} if it could not be found.
     *
     * @param groupId the group ID
     * @param nome the nome
     * @return the matching template
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template findByGroupIdNome(long groupId, String nome)
        throws NoSuchTemplateException, SystemException {
        Template template = fetchByGroupIdNome(groupId, nome);

        if (template == null) {
            StringBundler msg = new StringBundler(6);

            msg.append(_NO_SUCH_ENTITY_WITH_KEY);

            msg.append("groupId=");
            msg.append(groupId);

            msg.append(", nome=");
            msg.append(nome);

            msg.append(StringPool.CLOSE_CURLY_BRACE);

            if (_log.isWarnEnabled()) {
                _log.warn(msg.toString());
            }

            throw new NoSuchTemplateException(msg.toString());
        }

        return template;
    }

    /**
     * Returns the template where groupId = &#63; and nome = &#63; or returns <code>null</code> if it could not be found. Uses the finder cache.
     *
     * @param groupId the group ID
     * @param nome the nome
     * @return the matching template, or <code>null</code> if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template fetchByGroupIdNome(long groupId, String nome)
        throws SystemException {
        return fetchByGroupIdNome(groupId, nome, true);
    }

    /**
     * Returns the template where groupId = &#63; and nome = &#63; or returns <code>null</code> if it could not be found, optionally using the finder cache.
     *
     * @param groupId the group ID
     * @param nome the nome
     * @param retrieveFromCache whether to use the finder cache
     * @return the matching template, or <code>null</code> if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template fetchByGroupIdNome(long groupId, String nome,
        boolean retrieveFromCache) throws SystemException {
        Object[] finderArgs = new Object[] { groupId, nome };

        Object result = null;

        if (retrieveFromCache) {
            result = FinderCacheUtil.getResult(FINDER_PATH_FETCH_BY_GROUPIDNOME,
                    finderArgs, this);
        }

        if (result instanceof Template) {
            Template template = (Template) result;

            if ((groupId != template.getGroupId()) ||
                    !Validator.equals(nome, template.getNome())) {
                result = null;
            }
        }

        if (result == null) {
            StringBundler query = new StringBundler(4);

            query.append(_SQL_SELECT_TEMPLATE_WHERE);

            query.append(_FINDER_COLUMN_GROUPIDNOME_GROUPID_2);

            boolean bindNome = false;

            if (nome == null) {
                query.append(_FINDER_COLUMN_GROUPIDNOME_NOME_1);
            } else if (nome.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_GROUPIDNOME_NOME_3);
            } else {
                bindNome = true;

                query.append(_FINDER_COLUMN_GROUPIDNOME_NOME_2);
            }

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                qPos.add(groupId);

                if (bindNome) {
                    qPos.add(nome);
                }

                List<Template> list = q.list();

                if (list.isEmpty()) {
                    FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_GROUPIDNOME,
                        finderArgs, list);
                } else {
                    Template template = list.get(0);

                    result = template;

                    cacheResult(template);

                    if ((template.getGroupId() != groupId) ||
                            (template.getNome() == null) ||
                            !template.getNome().equals(nome)) {
                        FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_GROUPIDNOME,
                            finderArgs, template);
                    }
                }
            } catch (Exception e) {
                FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_GROUPIDNOME,
                    finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        if (result instanceof List<?>) {
            return null;
        } else {
            return (Template) result;
        }
    }

    /**
     * Removes the template where groupId = &#63; and nome = &#63; from the database.
     *
     * @param groupId the group ID
     * @param nome the nome
     * @return the template that was removed
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template removeByGroupIdNome(long groupId, String nome)
        throws NoSuchTemplateException, SystemException {
        Template template = findByGroupIdNome(groupId, nome);

        return remove(template);
    }

    /**
     * Returns the number of templates where groupId = &#63; and nome = &#63;.
     *
     * @param groupId the group ID
     * @param nome the nome
     * @return the number of matching templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public int countByGroupIdNome(long groupId, String nome)
        throws SystemException {
        FinderPath finderPath = FINDER_PATH_COUNT_BY_GROUPIDNOME;

        Object[] finderArgs = new Object[] { groupId, nome };

        Long count = (Long) FinderCacheUtil.getResult(finderPath, finderArgs,
                this);

        if (count == null) {
            StringBundler query = new StringBundler(3);

            query.append(_SQL_COUNT_TEMPLATE_WHERE);

            query.append(_FINDER_COLUMN_GROUPIDNOME_GROUPID_2);

            boolean bindNome = false;

            if (nome == null) {
                query.append(_FINDER_COLUMN_GROUPIDNOME_NOME_1);
            } else if (nome.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_GROUPIDNOME_NOME_3);
            } else {
                bindNome = true;

                query.append(_FINDER_COLUMN_GROUPIDNOME_NOME_2);
            }

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                qPos.add(groupId);

                if (bindNome) {
                    qPos.add(nome);
                }

                count = (Long) q.uniqueResult();

                FinderCacheUtil.putResult(finderPath, finderArgs, count);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return count.intValue();
    }

    /**
     * Returns the template where nome = &#63; and ativo = &#63; or throws a {@link br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException} if it could not be found.
     *
     * @param nome the nome
     * @param ativo the ativo
     * @return the matching template
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template findByNomeAtivo(String nome, boolean ativo)
        throws NoSuchTemplateException, SystemException {
        Template template = fetchByNomeAtivo(nome, ativo);

        if (template == null) {
            StringBundler msg = new StringBundler(6);

            msg.append(_NO_SUCH_ENTITY_WITH_KEY);

            msg.append("nome=");
            msg.append(nome);

            msg.append(", ativo=");
            msg.append(ativo);

            msg.append(StringPool.CLOSE_CURLY_BRACE);

            if (_log.isWarnEnabled()) {
                _log.warn(msg.toString());
            }

            throw new NoSuchTemplateException(msg.toString());
        }

        return template;
    }

    /**
     * Returns the template where nome = &#63; and ativo = &#63; or returns <code>null</code> if it could not be found. Uses the finder cache.
     *
     * @param nome the nome
     * @param ativo the ativo
     * @return the matching template, or <code>null</code> if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template fetchByNomeAtivo(String nome, boolean ativo)
        throws SystemException {
        return fetchByNomeAtivo(nome, ativo, true);
    }

    /**
     * Returns the template where nome = &#63; and ativo = &#63; or returns <code>null</code> if it could not be found, optionally using the finder cache.
     *
     * @param nome the nome
     * @param ativo the ativo
     * @param retrieveFromCache whether to use the finder cache
     * @return the matching template, or <code>null</code> if a matching template could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template fetchByNomeAtivo(String nome, boolean ativo,
        boolean retrieveFromCache) throws SystemException {
        Object[] finderArgs = new Object[] { nome, ativo };

        Object result = null;

        if (retrieveFromCache) {
            result = FinderCacheUtil.getResult(FINDER_PATH_FETCH_BY_NOMEATIVO,
                    finderArgs, this);
        }

        if (result instanceof Template) {
            Template template = (Template) result;

            if (!Validator.equals(nome, template.getNome()) ||
                    (ativo != template.getAtivo())) {
                result = null;
            }
        }

        if (result == null) {
            StringBundler query = new StringBundler(4);

            query.append(_SQL_SELECT_TEMPLATE_WHERE);

            boolean bindNome = false;

            if (nome == null) {
                query.append(_FINDER_COLUMN_NOMEATIVO_NOME_1);
            } else if (nome.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_NOMEATIVO_NOME_3);
            } else {
                bindNome = true;

                query.append(_FINDER_COLUMN_NOMEATIVO_NOME_2);
            }

            query.append(_FINDER_COLUMN_NOMEATIVO_ATIVO_2);

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                if (bindNome) {
                    qPos.add(nome);
                }

                qPos.add(ativo);

                List<Template> list = q.list();

                if (list.isEmpty()) {
                    FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_NOMEATIVO,
                        finderArgs, list);
                } else {
                    Template template = list.get(0);

                    result = template;

                    cacheResult(template);

                    if ((template.getNome() == null) ||
                            !template.getNome().equals(nome) ||
                            (template.getAtivo() != ativo)) {
                        FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_NOMEATIVO,
                            finderArgs, template);
                    }
                }
            } catch (Exception e) {
                FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_NOMEATIVO,
                    finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        if (result instanceof List<?>) {
            return null;
        } else {
            return (Template) result;
        }
    }

    /**
     * Removes the template where nome = &#63; and ativo = &#63; from the database.
     *
     * @param nome the nome
     * @param ativo the ativo
     * @return the template that was removed
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template removeByNomeAtivo(String nome, boolean ativo)
        throws NoSuchTemplateException, SystemException {
        Template template = findByNomeAtivo(nome, ativo);

        return remove(template);
    }

    /**
     * Returns the number of templates where nome = &#63; and ativo = &#63;.
     *
     * @param nome the nome
     * @param ativo the ativo
     * @return the number of matching templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public int countByNomeAtivo(String nome, boolean ativo)
        throws SystemException {
        FinderPath finderPath = FINDER_PATH_COUNT_BY_NOMEATIVO;

        Object[] finderArgs = new Object[] { nome, ativo };

        Long count = (Long) FinderCacheUtil.getResult(finderPath, finderArgs,
                this);

        if (count == null) {
            StringBundler query = new StringBundler(3);

            query.append(_SQL_COUNT_TEMPLATE_WHERE);

            boolean bindNome = false;

            if (nome == null) {
                query.append(_FINDER_COLUMN_NOMEATIVO_NOME_1);
            } else if (nome.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_NOMEATIVO_NOME_3);
            } else {
                bindNome = true;

                query.append(_FINDER_COLUMN_NOMEATIVO_NOME_2);
            }

            query.append(_FINDER_COLUMN_NOMEATIVO_ATIVO_2);

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                if (bindNome) {
                    qPos.add(nome);
                }

                qPos.add(ativo);

                count = (Long) q.uniqueResult();

                FinderCacheUtil.putResult(finderPath, finderArgs, count);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return count.intValue();
    }

    /**
     * Caches the template in the entity cache if it is enabled.
     *
     * @param template the template
     */
    @Override
    public void cacheResult(Template template) {
        EntityCacheUtil.putResult(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateImpl.class, template.getPrimaryKey(), template);

        FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_UUID_G,
            new Object[] { template.getUuid(), template.getGroupId() }, template);

        FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_GROUPIDNOME,
            new Object[] { template.getGroupId(), template.getNome() }, template);

        FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_NOMEATIVO,
            new Object[] { template.getNome(), template.getAtivo() }, template);

        template.resetOriginalValues();
    }

    /**
     * Caches the templates in the entity cache if it is enabled.
     *
     * @param templates the templates
     */
    @Override
    public void cacheResult(List<Template> templates) {
        for (Template template : templates) {
            if (EntityCacheUtil.getResult(
                        TemplateModelImpl.ENTITY_CACHE_ENABLED,
                        TemplateImpl.class, template.getPrimaryKey()) == null) {
                cacheResult(template);
            } else {
                template.resetOriginalValues();
            }
        }
    }

    /**
     * Clears the cache for all templates.
     *
     * <p>
     * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
     * </p>
     */
    @Override
    public void clearCache() {
        if (_HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE) {
            CacheRegistryUtil.clear(TemplateImpl.class.getName());
        }

        EntityCacheUtil.clearCache(TemplateImpl.class.getName());

        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_ENTITY);
        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
    }

    /**
     * Clears the cache for the template.
     *
     * <p>
     * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
     * </p>
     */
    @Override
    public void clearCache(Template template) {
        EntityCacheUtil.removeResult(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateImpl.class, template.getPrimaryKey());

        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);

        clearUniqueFindersCache(template);
    }

    @Override
    public void clearCache(List<Template> templates) {
        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);

        for (Template template : templates) {
            EntityCacheUtil.removeResult(TemplateModelImpl.ENTITY_CACHE_ENABLED,
                TemplateImpl.class, template.getPrimaryKey());

            clearUniqueFindersCache(template);
        }
    }

    protected void cacheUniqueFindersCache(Template template) {
        if (template.isNew()) {
            Object[] args = new Object[] {
                    template.getUuid(), template.getGroupId()
                };

            FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_UUID_G, args,
                Long.valueOf(1));
            FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_UUID_G, args,
                template);

            args = new Object[] { template.getGroupId(), template.getNome() };

            FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_GROUPIDNOME, args,
                Long.valueOf(1));
            FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_GROUPIDNOME, args,
                template);

            args = new Object[] { template.getNome(), template.getAtivo() };

            FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_NOMEATIVO, args,
                Long.valueOf(1));
            FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_NOMEATIVO, args,
                template);
        } else {
            TemplateModelImpl templateModelImpl = (TemplateModelImpl) template;

            if ((templateModelImpl.getColumnBitmask() &
                    FINDER_PATH_FETCH_BY_UUID_G.getColumnBitmask()) != 0) {
                Object[] args = new Object[] {
                        template.getUuid(), template.getGroupId()
                    };

                FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_UUID_G, args,
                    Long.valueOf(1));
                FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_UUID_G, args,
                    template);
            }

            if ((templateModelImpl.getColumnBitmask() &
                    FINDER_PATH_FETCH_BY_GROUPIDNOME.getColumnBitmask()) != 0) {
                Object[] args = new Object[] {
                        template.getGroupId(), template.getNome()
                    };

                FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_GROUPIDNOME,
                    args, Long.valueOf(1));
                FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_GROUPIDNOME,
                    args, template);
            }

            if ((templateModelImpl.getColumnBitmask() &
                    FINDER_PATH_FETCH_BY_NOMEATIVO.getColumnBitmask()) != 0) {
                Object[] args = new Object[] {
                        template.getNome(), template.getAtivo()
                    };

                FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_NOMEATIVO, args,
                    Long.valueOf(1));
                FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_NOMEATIVO, args,
                    template);
            }
        }
    }

    protected void clearUniqueFindersCache(Template template) {
        TemplateModelImpl templateModelImpl = (TemplateModelImpl) template;

        Object[] args = new Object[] { template.getUuid(), template.getGroupId() };

        FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_UUID_G, args);
        FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_UUID_G, args);

        if ((templateModelImpl.getColumnBitmask() &
                FINDER_PATH_FETCH_BY_UUID_G.getColumnBitmask()) != 0) {
            args = new Object[] {
                    templateModelImpl.getOriginalUuid(),
                    templateModelImpl.getOriginalGroupId()
                };

            FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_UUID_G, args);
            FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_UUID_G, args);
        }

        args = new Object[] { template.getGroupId(), template.getNome() };

        FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_GROUPIDNOME, args);
        FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_GROUPIDNOME, args);

        if ((templateModelImpl.getColumnBitmask() &
                FINDER_PATH_FETCH_BY_GROUPIDNOME.getColumnBitmask()) != 0) {
            args = new Object[] {
                    templateModelImpl.getOriginalGroupId(),
                    templateModelImpl.getOriginalNome()
                };

            FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_GROUPIDNOME, args);
            FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_GROUPIDNOME, args);
        }

        args = new Object[] { template.getNome(), template.getAtivo() };

        FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_NOMEATIVO, args);
        FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_NOMEATIVO, args);

        if ((templateModelImpl.getColumnBitmask() &
                FINDER_PATH_FETCH_BY_NOMEATIVO.getColumnBitmask()) != 0) {
            args = new Object[] {
                    templateModelImpl.getOriginalNome(),
                    templateModelImpl.getOriginalAtivo()
                };

            FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_NOMEATIVO, args);
            FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_NOMEATIVO, args);
        }
    }

    /**
     * Creates a new template with the primary key. Does not add the template to the database.
     *
     * @param templateId the primary key for the new template
     * @return the new template
     */
    @Override
    public Template create(long templateId) {
        Template template = new TemplateImpl();

        template.setNew(true);
        template.setPrimaryKey(templateId);

        String uuid = PortalUUIDUtil.generate();

        template.setUuid(uuid);

        return template;
    }

    /**
     * Removes the template with the primary key from the database. Also notifies the appropriate model listeners.
     *
     * @param templateId the primary key of the template
     * @return the template that was removed
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a template with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template remove(long templateId)
        throws NoSuchTemplateException, SystemException {
        return remove((Serializable) templateId);
    }

    /**
     * Removes the template with the primary key from the database. Also notifies the appropriate model listeners.
     *
     * @param primaryKey the primary key of the template
     * @return the template that was removed
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a template with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template remove(Serializable primaryKey)
        throws NoSuchTemplateException, SystemException {
        Session session = null;

        try {
            session = openSession();

            Template template = (Template) session.get(TemplateImpl.class,
                    primaryKey);

            if (template == null) {
                if (_log.isWarnEnabled()) {
                    _log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
                }

                throw new NoSuchTemplateException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
                    primaryKey);
            }

            return remove(template);
        } catch (NoSuchTemplateException nsee) {
            throw nsee;
        } catch (Exception e) {
            throw processException(e);
        } finally {
            closeSession(session);
        }
    }

    @Override
    protected Template removeImpl(Template template) throws SystemException {
        template = toUnwrappedModel(template);

        Session session = null;

        try {
            session = openSession();

            if (!session.contains(template)) {
                template = (Template) session.get(TemplateImpl.class,
                        template.getPrimaryKeyObj());
            }

            if (template != null) {
                session.delete(template);
            }
        } catch (Exception e) {
            throw processException(e);
        } finally {
            closeSession(session);
        }

        if (template != null) {
            clearCache(template);
        }

        return template;
    }

    @Override
    public Template updateImpl(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template template)
        throws SystemException {
        template = toUnwrappedModel(template);

        boolean isNew = template.isNew();

        TemplateModelImpl templateModelImpl = (TemplateModelImpl) template;

        if (Validator.isNull(template.getUuid())) {
            String uuid = PortalUUIDUtil.generate();

            template.setUuid(uuid);
        }

        Session session = null;

        try {
            session = openSession();

            if (template.isNew()) {
                session.save(template);

                template.setNew(false);
            } else {
                session.merge(template);
            }
        } catch (Exception e) {
            throw processException(e);
        } finally {
            closeSession(session);
        }

        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);

        if (isNew || !TemplateModelImpl.COLUMN_BITMASK_ENABLED) {
            FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
        }
        else {
            if ((templateModelImpl.getColumnBitmask() &
                    FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID.getColumnBitmask()) != 0) {
                Object[] args = new Object[] { templateModelImpl.getOriginalUuid() };

                FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_UUID, args);
                FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID,
                    args);

                args = new Object[] { templateModelImpl.getUuid() };

                FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_UUID, args);
                FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID,
                    args);
            }

            if ((templateModelImpl.getColumnBitmask() &
                    FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID_C.getColumnBitmask()) != 0) {
                Object[] args = new Object[] {
                        templateModelImpl.getOriginalUuid(),
                        templateModelImpl.getOriginalCompanyId()
                    };

                FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_UUID_C, args);
                FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID_C,
                    args);

                args = new Object[] {
                        templateModelImpl.getUuid(),
                        templateModelImpl.getCompanyId()
                    };

                FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_UUID_C, args);
                FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID_C,
                    args);
            }

            if ((templateModelImpl.getColumnBitmask() &
                    FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_GROUPID.getColumnBitmask()) != 0) {
                Object[] args = new Object[] {
                        templateModelImpl.getOriginalGroupId()
                    };

                FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_GROUPID, args);
                FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_GROUPID,
                    args);

                args = new Object[] { templateModelImpl.getGroupId() };

                FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_GROUPID, args);
                FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_GROUPID,
                    args);
            }
        }

        EntityCacheUtil.putResult(TemplateModelImpl.ENTITY_CACHE_ENABLED,
            TemplateImpl.class, template.getPrimaryKey(), template);

        clearUniqueFindersCache(template);
        cacheUniqueFindersCache(template);

        return template;
    }

    protected Template toUnwrappedModel(Template template) {
        if (template instanceof TemplateImpl) {
            return template;
        }

        TemplateImpl templateImpl = new TemplateImpl();

        templateImpl.setNew(template.isNew());
        templateImpl.setPrimaryKey(template.getPrimaryKey());

        templateImpl.setUuid(template.getUuid());
        templateImpl.setTemplateId(template.getTemplateId());
        templateImpl.setCompanyId(template.getCompanyId());
        templateImpl.setGroupId(template.getGroupId());
        templateImpl.setUserId(template.getUserId());
        templateImpl.setNome(template.getNome());
        templateImpl.setEstilo(template.getEstilo());
        templateImpl.setAtivo(template.isAtivo());
        templateImpl.setCabecalho(template.getCabecalho());
        templateImpl.setRodape(template.getRodape());
        templateImpl.setCorpo(template.getCorpo());
        templateImpl.setDataCriacao(template.getDataCriacao());
        templateImpl.setDataAtualizacao(template.getDataAtualizacao());
        templateImpl.setThumbnailFileEntryId(template.getThumbnailFileEntryId());
        templateImpl.setThumbnailURL(template.getThumbnailURL());

        return templateImpl;
    }

    /**
     * Returns the template with the primary key or throws a {@link com.liferay.portal.NoSuchModelException} if it could not be found.
     *
     * @param primaryKey the primary key of the template
     * @return the template
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a template with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template findByPrimaryKey(Serializable primaryKey)
        throws NoSuchTemplateException, SystemException {
        Template template = fetchByPrimaryKey(primaryKey);

        if (template == null) {
            if (_log.isWarnEnabled()) {
                _log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
            }

            throw new NoSuchTemplateException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
                primaryKey);
        }

        return template;
    }

    /**
     * Returns the template with the primary key or throws a {@link br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException} if it could not be found.
     *
     * @param templateId the primary key of the template
     * @return the template
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchTemplateException if a template with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template findByPrimaryKey(long templateId)
        throws NoSuchTemplateException, SystemException {
        return findByPrimaryKey((Serializable) templateId);
    }

    /**
     * Returns the template with the primary key or returns <code>null</code> if it could not be found.
     *
     * @param primaryKey the primary key of the template
     * @return the template, or <code>null</code> if a template with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template fetchByPrimaryKey(Serializable primaryKey)
        throws SystemException {
        Template template = (Template) EntityCacheUtil.getResult(TemplateModelImpl.ENTITY_CACHE_ENABLED,
                TemplateImpl.class, primaryKey);

        if (template == _nullTemplate) {
            return null;
        }

        if (template == null) {
            Session session = null;

            try {
                session = openSession();

                template = (Template) session.get(TemplateImpl.class, primaryKey);

                if (template != null) {
                    cacheResult(template);
                } else {
                    EntityCacheUtil.putResult(TemplateModelImpl.ENTITY_CACHE_ENABLED,
                        TemplateImpl.class, primaryKey, _nullTemplate);
                }
            } catch (Exception e) {
                EntityCacheUtil.removeResult(TemplateModelImpl.ENTITY_CACHE_ENABLED,
                    TemplateImpl.class, primaryKey);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return template;
    }

    /**
     * Returns the template with the primary key or returns <code>null</code> if it could not be found.
     *
     * @param templateId the primary key of the template
     * @return the template, or <code>null</code> if a template with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Template fetchByPrimaryKey(long templateId)
        throws SystemException {
        return fetchByPrimaryKey((Serializable) templateId);
    }

    /**
     * Returns all the templates.
     *
     * @return the templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Template> findAll() throws SystemException {
        return findAll(QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
    }

    /**
     * Returns a range of all the templates.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param start the lower bound of the range of templates
     * @param end the upper bound of the range of templates (not inclusive)
     * @return the range of templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Template> findAll(int start, int end) throws SystemException {
        return findAll(start, end, null);
    }

    /**
     * Returns an ordered range of all the templates.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.TemplateModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param start the lower bound of the range of templates
     * @param end the upper bound of the range of templates (not inclusive)
     * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
     * @return the ordered range of templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Template> findAll(int start, int end,
        OrderByComparator orderByComparator) throws SystemException {
        boolean pagination = true;
        FinderPath finderPath = null;
        Object[] finderArgs = null;

        if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
                (orderByComparator == null)) {
            pagination = false;
            finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL;
            finderArgs = FINDER_ARGS_EMPTY;
        } else {
            finderPath = FINDER_PATH_WITH_PAGINATION_FIND_ALL;
            finderArgs = new Object[] { start, end, orderByComparator };
        }

        List<Template> list = (List<Template>) FinderCacheUtil.getResult(finderPath,
                finderArgs, this);

        if (list == null) {
            StringBundler query = null;
            String sql = null;

            if (orderByComparator != null) {
                query = new StringBundler(2 +
                        (orderByComparator.getOrderByFields().length * 3));

                query.append(_SQL_SELECT_TEMPLATE);

                appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
                    orderByComparator);

                sql = query.toString();
            } else {
                sql = _SQL_SELECT_TEMPLATE;

                if (pagination) {
                    sql = sql.concat(TemplateModelImpl.ORDER_BY_JPQL);
                }
            }

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                if (!pagination) {
                    list = (List<Template>) QueryUtil.list(q, getDialect(),
                            start, end, false);

                    Collections.sort(list);

                    list = new UnmodifiableList<Template>(list);
                } else {
                    list = (List<Template>) QueryUtil.list(q, getDialect(),
                            start, end);
                }

                cacheResult(list);

                FinderCacheUtil.putResult(finderPath, finderArgs, list);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return list;
    }

    /**
     * Removes all the templates from the database.
     *
     * @throws SystemException if a system exception occurred
     */
    @Override
    public void removeAll() throws SystemException {
        for (Template template : findAll()) {
            remove(template);
        }
    }

    /**
     * Returns the number of templates.
     *
     * @return the number of templates
     * @throws SystemException if a system exception occurred
     */
    @Override
    public int countAll() throws SystemException {
        Long count = (Long) FinderCacheUtil.getResult(FINDER_PATH_COUNT_ALL,
                FINDER_ARGS_EMPTY, this);

        if (count == null) {
            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(_SQL_COUNT_TEMPLATE);

                count = (Long) q.uniqueResult();

                FinderCacheUtil.putResult(FINDER_PATH_COUNT_ALL,
                    FINDER_ARGS_EMPTY, count);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(FINDER_PATH_COUNT_ALL,
                    FINDER_ARGS_EMPTY);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return count.intValue();
    }

    @Override
    protected Set<String> getBadColumnNames() {
        return _badColumnNames;
    }

    /**
     * Initializes the template persistence.
     */
    public void afterPropertiesSet() {
        String[] listenerClassNames = StringUtil.split(GetterUtil.getString(
                    com.liferay.util.service.ServiceProps.get(
                        "value.object.listener.br.mp.mprj.portal.portlet.gestaomensagens.service.model.Template")));

        if (listenerClassNames.length > 0) {
            try {
                List<ModelListener<Template>> listenersList = new ArrayList<ModelListener<Template>>();

                for (String listenerClassName : listenerClassNames) {
                    listenersList.add((ModelListener<Template>) InstanceFactory.newInstance(
                            getClassLoader(), listenerClassName));
                }

                listeners = listenersList.toArray(new ModelListener[listenersList.size()]);
            } catch (Exception e) {
                _log.error(e);
            }
        }
    }

    public void destroy() {
        EntityCacheUtil.removeCache(TemplateImpl.class.getName());
        FinderCacheUtil.removeCache(FINDER_CLASS_NAME_ENTITY);
        FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
        FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
    }
}
